{Level.PAS}

uses Crt;

const
 MAXx = 128;
 MAXy = 32;
 TailleX = 10;
 TailleY = 6;
 Start = 64;
 MAXObject = 100;
 MAXgx = 32;
 MAXgy = 32;
 MAXDRAW = 50;
 MAXgD = 4;


type
 Tab = ARRAY [0..MAXx-1] of array [0..MAXy-1] of byte;
 BigTab = ARRAY [0..MAXObject-1] of byte;
 GraphTab = array [0..1] of ARRAY [0..MAXgD-1] of array [0..MAXgy-1] of array [0..MAXDRAW-1] of byte;


var
 C: Char;
 StartX,StartY,Screen: byte;
 i,j,k,xs,ys: Integer;
 Pict,Test: Tab;
 Liaison: BigTab;
 Ch: Char;
 s : String;
 Continuer : BOOLEAN;
 Mem: GraphTab;
 xresolution,yresolution,video_seg:word;
 OrigMode :Integer;

label
     FinLevel;

function FileExists(FileName: String): Boolean;
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;  { Set file access to read only }
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

procedure SaveFile(FileName: String);
var
 F: Text;
 i,j: Integer;
 Ch: char;

begin
 Assign(F,FileName);
 ReWrite(F);
 Write(F,chr(StartX));
 Write(F,chr(StartY));
 for j := 0 to MAXy - 1 do
     for i := 0 to (MAXx - 1) do
            Write(F, Chr(Pict[i][j]));
 for j := 0 to MAXy - 1 do
     for i := 0 to (MAXx - 1) do
            Write(F, Chr(Test[i][j]));
 Close(F);
end;

procedure OpenFile(FileName: String);
var
 F: Text;
 xn,yn,i,j,k: Integer;
 Ch: char;

begin
 Assign(F,FileName);
 Reset(F);
 read(F,Ch); {xnd}
 read(F,Ch); {ynd}
 read(F,Ch); {xd}
 read(F,Ch); {yd}
 FOR yn := 0 TO 3 do
     FOR xn := 0 TO 7 do
         begin
         FOR j := 0 TO 7 do
             FOR i := 0 TO 14 do
                 begin
                 read(F,Ch);
                 pict[xn*15+i][8*yn+j]:= ord(Ch);
                 end;
         FOR j := 0 TO 7 do
             FOR i := 0 TO 14 do
                 begin
                 read(F,Ch);
                 test[xn*15+i][8*yn+j]:= ord(Ch);
                 end;
         end;
end;

procedure OpenFileGraph(FileName: String);
var
 F: Text;
 i,j,k: Integer;
 Ch: char;

begin
 Assign(F,FileName);
 Reset(F);
 k:=0;
 while (not Eof(F)) and (k<MAXDRAW) do
  begin
    for j := 0 to MAXy - 1 do
        for i := 0 to (MAXgD - 1) do
            Begin
            Read(F, Ch);
            Mem[screen][i][j][k] := ord(ch);
            end;
    k:= k + 1;
  end;
end;

procedure init_Mcga;
begin
yresolution:=200;
xresolution:=320;
video_seg:=$A000;
asm
mov xresolution,320d
mov ax,13h
int 10h
end
end;

procedure sp(xl,yl,coul:word); assembler;
asm
 mov ax,yl
 mul xresolution
 mov bx,xl
 add bx,ax
 mov es,video_seg
 mov ax,coul
 mov es:[bx],al
end;

procedure box(xl,yl,xl1,yl1,coul:word);assembler;
var i:word;
label a,b;
asm
 mov es,video_seg
 mov dx,xl
 mov i,dx
 a:
 mov Cx,yl
 b:
 mov ax,cx
 mul xresolution
 mov bx,i
 add bx,ax

 mov ax,coul
 mov es:[bx],al
 inc cx
 cmp cx,yl1
 jbe b
 inc i
 mov dx,i
 cmp dx,xl1
 jbe a
end;

procedure PrintGraph(No,xj,yj:integer);
var i,j,k:integer;
c,d,coul:byte;

begin
    for j:=0 to MAXgy-1 do
        for i:=0 to MAXgd-1 do
            begin
                 c:=Mem[screen][i][j][No];
                 d:=1;
                 for k := 0 to 7 do
                     begin
                          if (c and d) = 0 then coul:=18
                             else coul:=75;
                          d:=2*d;
                          sp(i*8+7-k+xj,j+yj,coul);
                     end;
              end;
end;


procedure PrintLevel(xs,ys:integer);
var i,j:integer;
    cc: byte;
begin
  for i:=xs to xs+Taillex - 1 do
     for j:= ys to ys+Tailley - 1 do
         begin
             if Screen=0 then cc:=Pict[i][j] else cc:=Test[i][j];
             if cc>0 then
                         PrintGraph(cc-1,(i-xs)*32,(j-ys)*32)
                         else
                         Box((i-xs)*32,(j-ys)*32,(i-xs+1)*32,(j-ys+1)*32,18);
         end;

end;


procedure PrintScreen(xs,ys: integer);
var i,j:integer;
    cc: byte;
begin
 clrscr;
 GotoXY(1,22);
 writeln('4, 2, 8, 6, '' '', DEL, * -> Save,');
 if Screen=0 then write('Graph Mode ') else write('Test Mode ');
 writeln(':Screen at ',xs,'/',ys);

 for i:=xs to xs+Taillex - 1 do
     for j:= ys to ys+Tailley - 1 do
         begin
             if Screen=0 then cc:=Pict[i][j] else cc:=Test[i][j];
             if cc>0 then begin
                             GotoXY(i+1-xs,j+1-ys);
                             Write(Chr(cc+Start));
                         end;
         end;

end;

procedure DefineLiaison;
var
   c,d: char;

begin
 TextMode(OrigMode);

 clrscr;
 c:='0'; d:='0';
 writeln('Which graph will be pointed to ?');
 while (ord(c)<=Start) or (ord(c)>=Start+MAXObject) do
  C := Readkey;

 writeln('Which Test for ',c,' ?');
 while (ord(d)<=Start) or (ord(d)>=Start+MAXObject) do
  d := Readkey;
 Liaison[ord(c)-start]:=ord(d)-start;
 Init_Mcga;

end;

begin
  { Get file to read from command line : ParamStr(1) }

  OrigMode := LastMode;

  clrscr;
  Screen:=0;
  Write('Enter File Graph Name: ');
{  Readln(s);}
  s:='Graph.d32';
  if FileExists(s) then
   begin
   Writeln('Graph File exists');
   OpenFileGraph(s);
  end
 else
   Begin
   Writeln('Graph File not found');
   Goto FinLevel;
   end;
  Screen:=1;
  Write('Enter File test Graph Name: ');
{  Readln(s); }
  s:='Test.d32';
  if FileExists(s) then
   begin
   Writeln('Test Graph File exists');
   OpenFileGraph(s);
  end
 else
   Begin
   Writeln('Test Graph File not found');
   Goto FinLevel;
   end;

  Write('Enter File Name: ');
  if ParamStr(1)='' then Readln(s) else s:=ParamStr(1);
  Writeln('You typed: ',s);

 if FileExists(s) then
   begin
   Writeln('File exists');
   OpenFile(s);
  end
 else
   Begin
   Writeln('File not found');
   writeln('New file:',s);
   end;
 writeln('Press 4, 2, 8, 6 to move the cursor');
 writeln('Press SPACE to switch betwen Graph Screen and Test Screen');
 writeln('Press DEL to destroy the graph and the test (or only test)');
 writeln('Press * to save the level and /to define where Fer must start');
 writeln('When you press +, you will associate a test at a graph:');
 writeln('Example : If you want when you press graph A, test X');
 writeln('will be automatically pressed, Press : ');
 writeln(' + to enter the DefineInput, then press A, then X');
 writeln('Press A B ...(Ascii table) to draw a graph (or a test if you are in test scren)');
 writeln;
 writeln('Press ENTER to start AND TO QUIT');
 readln;

 init_Mcga;
 i:=0; j:=0; xs:=0; ys:=0;Screen:=0;

 Continuer:=TRUE;

 while continuer do
 begin
  PrintLevel(xs,ys);
{  GotoXY(i-xs+1,j-ys+1);
  write('#');}
  Box((i-xs)*32+1,(j-ys)*32+1,(i-xs+1)*32-1,(j-ys+1)*32-1,28);
  C := Readkey;
  if (c = '4') and (i > 0) then
                                begin
                                i:= i - 1;
                                if xs>i then xs:=i;
                                end
  else if (c = '6') and (i< (MAXx - 1)) then begin
                                        i:= i + 1;
                                        if xs+TailleX-1<i then
                                           xs:=i-TailleX+1;
                                        end
  else if (c = '8') and (j>0) then
                         begin
                         j:=j-1;
                         if ys>j then ys:=j;
                         end
  else if (c = '2') and (j<(MAXy - 1)) then
                            begin
                             j:=j + 1;
                             if ys+TailleY-1<j then
                                              ys:=j-TailleY+1;
                            end
  else if c = chr(13) then Continuer := FALSE
  else if c = ' 'then Screen := 1-Screen
  else if c= '*' then SaveFile(s)
  else if c = chr(8)  then
          begin
              IF screen = 0 then
                        begin
                             Pict[i][j]:=0;
                             Test[i][j]:=0;
                        end
                            else
                             Test[i][j]:=0;
          end
  else if c='+' then DefineLiaison
  else if c='/' then
                begin
                 StartX:=i;
                 StartY:=j;
                 TextMode(OrigMode);
                 writeln('New start at ',StartX,',',StartY);
                 readln;
                 Init_Mcga;
                end
  else if (ord(c)>Start) and (ord(c)<Start+MAXObject) then
          begin
           IF Screen=0 then
                           begin
                           Pict[i][j]:=ord(c)-Start;
                           Test[i][j]:=Liaison[Pict[i][j]];
                           end
                       else Test[i][j]:=ord(c)-Start;
          end;
  end;
FinLevel:
  TextMode(OrigMode);

end.
