;  	FERNANDO 3 TI-92 ASM Version 3.0
;
;	Copyright (C) 1998-1999-2000 Plissier Patrick
;

	include "tios.h"
	include "genlib.h"
	include "pk92lib.h"


MAX_LEVEL	EQU	4

	xdef _main
	xdef _comment

	ifne	CALC_TI92PLUS
	xdef	_ti89
	xdef	_ti92plus
	endif

;**********************************************
;
;		Introduction
;
;**********************************************
_main:
	jsr	genlib::init
	genlib::PUSH_DSCREEN	d0
	move.l	d0,Screen1
	jsr	genlib::set_dscreen_int
	jsr	genlib::set_dscreen_function
	jsr	genlib::init_dscreen
	tst.w	d0
	beq.s	\quit
	move.w	d0,DScreen_hd
	move.l	a0,Screen2
	clr.w	Tps

	jsr	genlib::change_update

\quit:
	genlib::POP_DSCREEN
	jmp	genlib::quit

NewGame:
	move.w #3,Vi 
	clr.w  SubLevel

 clr.l   d0
 move.w  MaxSprite,d0
 mulu.w  #148,d0		   ; The sprites
 add.l   #132,d0		   ; And Fernand's back
 add.l   #7680,d0 		   ; And (MaxXn+1)*(MaxYn+1)*15*8*2
 add.l   #4150,d0		   ; And GrayScale !
 move.l  d0,-(a7)
 jsr     tios::HeapAlloc           ; Call the romlib function
 addq.l   #4,a7                   ; Restore the stack pointer
 tst.l   d0
 beq 	 _main		           ; Not enougth memory
 move.w  d0,-(a7)
 jsr     tios::HeapFree		   ; Destroy the Handle
 addq.l	#2,a7


; Rservation de la mmoire pour les sprites
 clr.l   d0
 move.w  MaxSprite,d0
 mulu.w  #148,d0		   ; The sprites
 add.W   #132,d0		   ; Fernand's back
 move.l  d0,-(a7)
 jsr     tios::HeapAlloc           ; Call the romlib function
 addq.l  #4,a7                   	; Restore the stack pointer
 move.w  d0,sprite_handle
 tios::DEREF	 d0,a0
 move.l  a0,sprite_adr

 clr.l d0   
 move.w MaxSprite,d0
 lsl.w #4,d0
 move.l sprite_adr,a0
 add.l d0,a0
 move.l a0,sprite_back_store


;***********************************************
;
; 		Dbut du niveau !
;
;***********************************************

StartLevel:
; On copie le niveau ailleurs : Plus tard, decompactage
	move.w SubLevel(Pc),d0
	cmp.w	#MAX_LEVEL-1,d0
	beq	exit

	lea	Level(PC),a0
	jsr     pk92lib::Extract
	tst.b	d0
	bne	exit
	move.l	(a1)+,xnd
 	move.l	a1,level_adr

	clr.w  Cf
	clr.w  Bj
	clr.w  v

; Dlimiter dpart
	clr.l	 xj
	clr.l   xn
	clr.l   d0
	move.b  xnd,d0
	move.w  d0,xn
	move.b  ynd,d0
	move.w  d0,yn
	move.b  xd,d0
	lsl.l   #4,d0
	move.w  d0,xj
	move.b  yd,d0
	lsl.l   #4,d0
	move.w  d0,yj

; Init
 clr.w action ; DEBOUT
 lea    Tombe(PC),a6
 move.l a6,ADR_action

; Initialisation pour le statut
 SetFont #0

; Dbut du sous-niveau 
LevelLoop:
 bsr   GetLevelADR
 clr.w NbrSprite
 bsr   PutDecor   


; Inialisation indispensable
 clr.l d0
 clr.l d1
 clr.w EffacerDecor
 bsr Statut
 
 clr.w timer

; Del a bug
 lea	Marche(PC),a0
 cmp.l	ADR_action,a0
 bne	main_loop
 lea    Tombe(PC),a6
 move.l	a6,ADR_action
 
main_loop:

; Affichage du personnage
 move.l #0,d2
 move.w xj,d0
 move.w yj,d1
 move.w action,d2
 move.w v,d3
 beq    AffSuite
 move.w #32,d2
 subq  #1,d3
 move.W d3,v
AffSuite:
 add.w  sens,d2
 lea    fernand(PC),a0
 move.l sprite_back_store,a3
 bsr PutFer

; Pour tous les sprites affichage
 move.w NbrSprite,d3
 move.w d3,ExNbrSprite
 beq	PasDeSprite
 subq  #1,d3
 lea 	Sprite(PC),a0
 move.l sprite_adr,a1
SpriteAffLoop:
 move.w 6(a1),d0
 move.w 8(a1),d1
 move.b 10(a1),d2
 bsr    PutFer
 lea    16(a1),a1
 dbra   d3,SpriteAffLoop
PasDeSprite:
 move.l a3,SpriteAdrTemp

 move.w xj,d0
 move.w yj,d1

 bsr GetKeyStat
 btst.b #0,keystat		; 2ND ?
 beq exit

 move.l ADR_action,a6

; Left ?
 btst.b #4,keystat
 bne    NoLeft

 move.w #1,sens
 sub.w  vith,d0
 bsr GetTest
 cmp.b #1,d2
 beq SuiteAct
 move.w d0,xj
 bra SuiteAct

; Right ?
NoLeft: 
 btst.b #6,keystat
 bne    SuiteAct

 clr.w sens
 add.w  vith,d0
 bsr GetTest
 cmp.b #1,d2
 beq SuiteAct
 move.w d0,xj

SuiteAct:

; test sortie de l'ecran  Gauche et  droite
 cmp.b  #224,d0
 bls    Suitegd
SortiegdEntree:
 move.w xn,d3
 move.l level,a4
 move.l leveltest,a5
 move.w d3,d7
 cmp.b  #240,d0
 bhi    SortieGauche
;SortieDroite
 cmp.w  #7,d3	; MaxXn
 beq 	SortieXDB
 addq   #1,d3
 move.w d3,xn
 bsr    GetLevelADR
 clr.w  d0
 move.w d0,xj
 move.w yj,d1
 bsr GetTest
 cmp.b  #1,d2
 bne    LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,xn
SortieXDB:
 move.w #224,d0
 move.w d0,xj
 clr.w  Mx
 bra Suitegd
SortieGauche: 
 move.w xn,d0
 beq    SortieXGB
 subq  #1,d0
 move.w d0,xn
 bsr    GetLevelADR
 move.w #224,d0
 move.w d0,xj
 move.w yj,d1
 bsr    GetTest
 cmp.b  #1,d2
 bne    LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,xn
SortieXGB:
 clr.w  xj
 clr.w  Mx
Suitegd:

; Jump to the action of Fer
 jmp (a6)
FinSR:

; Test sortie Haut/Bas
 move.w yj,d1
 cmp.b  #111,d1
 bls 	Suitehb
 move.l a6,ADR_action
 moveq #0,d3
 move.w yn,d3
 move.l level,a4 	    ; Save Data
 move.l leveltest,a5
 move.w d3,d7
 cmp.b  #200,d1
 bhi    SortieHaut
;SortieBas
 cmp.w  #3,d3 		  ;MaxYn
 beq    SortieYBB
 addq   #1,d3
 move.w d3,yn
 bsr    GetLevelADR
 clr.w  d1
 move.W d1,yj
 move.w xj,d0
 bsr    GetTest
 cmp.b  #1,d2
 bne    LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,yn
 move.w #112,d1
 move.W d1,yj
 lea    Marche(PC),a6
 bra    Suitehb
SortieYBB:
 bra    Sortie
SortieHaut:
 tst.b  d3
 beq    SortieYHB
 sub.w  #1,d3
 move.w d3,yn
 bsr    GetLevelADR
 move.w #112,d1
 move.W d1,yj
 move.w xj,d0
 bsr GetTest
 cmp.b #1,d2
 bne LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,yn
SortieYHB:
 clr.w My
 clr.w yj
Suitehb:

; Lecture des options
	move.w xj(Pc),d3
	move.w yj(Pc),d4
	lea    Test(PC),a2
	bsr    Lecture
	lsl.w  #2,d2
	move.l 0(a2,d2),a0
 lea    Teste(PC),a5
 jmp 	(a0)
Teste:
 add.w  #15,d4
 bsr    Lecture
 lsl.l  #2,d2
 move.l 0(a2,d2),a0
 lea    Teste2(PC),a5
 jmp 	(a0)
Teste2:
 add.w  #15,d3
 bsr    Lecture
 lsl.l  #2,d2
 move.l 0(a2,d2),a0
 lea    Teste3(PC),a5
 jmp    (a0)
Teste3:
 sub.w  #15,d4
 bsr    Lecture
 lsl.l  #2,d2
 move.l 0(a2,d2),a0
 lea    Teste4(PC),a5
 jmp 	(a0)
Teste4:

; Pour tous les sprites, gestion
 move.w NbrSprite,d3
 beq	PasDeSpriteGest
 subq   #1,d3
 move.l sprite_adr,a0
 lea    SpriteADR,a2
SpriteGestLoop:
 moveq	#0,d0
 move.b (a0),d0
 lsl.w  #2,d0
 move.l 0(a2,d0),a1
 jmp    (a1)
Retour:
 lea 16(a0),a0
RetourSansInc:
 dbra   d3,SpriteGestLoop
PasDeSpriteGest:

; save action, why ?
 move.l a6,ADR_action

; Attente ...
\delay:
 tst.w timer
 bne   \delay

; Rafraichissement de l'cran ...
\refresh
 tst.w vbl_phase
 bne   \refresh

; Prparation pour le prochain dlai
 move.w Speed,d3
 move.W d3,timer

; Pour tous les sprites, effacement
 move.w ExNbrSprite,d3
 move.l SpriteAdrTemp,a0
SpriteAffDelLoop:
 lea	-132(a0),a0
 bsr    RemoveSprite
 dbra   d3,SpriteAffDelLoop

; On efface le dcor s'il le faut,
 move.w EffacerDecor,d3
 beq    SuiteDecorEffacer
 subq   #1,d3
 lea    EffacerADR(PC),a0
 moveq	#0,d0
 moveq	#0,d1
 moveq	#0,d2
DecorEffacerLoop:
 move.w (a0)+,d0
 move.w (a0)+,d1
 bsr    PutSprite
 dbra   d3,DecorEffacerLoop
 move.w d2,EffacerDecor
SuiteDecorEffacer:

 bra   main_loop

exit:
 move.w #1,Vi

Sortie:

; jsr fer3lib::Destroy_Level
 jsr	pk92lib::FreeMem

 cmp.w #255,xn
 beq   LevelCompleted

 move.w Vi,d0
 subq   #1,d0
 beq    Exit
 move.w d0,Vi
 bra    StartLevel
LevelCompleted:
 addq.w  #1,SubLevel
 bra    StartLevel

Exit:
; Dtruire la rserve de sprite

 move.w  sprite_handle,d0
 move.w  d0,-(a7)
 jsr     tios::HeapFree
 addq.l	#2,a7

; Eteindre les 4 couleurs
 jsr gray4lib::off

; Restore int #1
 move.w #$0700,d0
 trap #1
 bclr.b #2,$600001
 move.l oldint#1(PC),$64
 bset.b #2,$600001
 trap #1

	rts

;*****************************************************
;
; 		Les diffrentes actions du personnage
;
;*****************************************************

; DATA
action:		dc.w 0
sens:		dc.w 0
a:		dc.w 0
v:		dc.w 0
ADR_action   	dc.l 0
St:		dc.w 0
b1:		dc.w 0
Mx:		dc.w 0
My:		dc.w 0

; JUMP
Saut:
 move.w St,d3
 beq   Sau2
 and.w #7,d3
 bne   Sau1
 btst.b #3,keystat
 beq   Sau1
 move.w #1,St
Sau1:
 subq.w #1,St
 move.w #18,action  ;SAUT
 move.w xj,d0
 move.w yj,d1
 sub.w  vith,d1
 cmp.w #112,d1
 bhi Sau3
 bsr GetTest
 cmp.b #1,d2
 beq  FinSR
Sau3:
 move.w d1,yj
 bra  FinSR
Sau2:
 lea  Tombe(PC),a6

; FALL & WALK
Tombe:
 move.w xj,d0
 move.w yj,d1
 add.w  vith,d1
 bsr GetTest
 cmp.b #1,d2
 beq Marche
 move.w d1,yj
 move.w #20,action ; TOMBE
 bra FinSR

Marche:
 btst.b #3,keystat
 bne  Mar1
 move.w Hauteur,d0
 move.W d0,St ; HAUTEUR_SAUT
 Lea  Saut(PC),a6
 bra  Sau1

Mar1:
 cmp.b #255,keystat
 bne   Mar2
 and.w #255,b1
 beq   PasseTemps
 add.w #1,b1
 clr.w action ; DEBOUT
 bra FinSR

Mar2:
 move.w #1,b1
 move.w #2,action ; MARCHE
 move.w a,d0      ; Gre les diffrentes animations
 addq   #1,d0
 and.w  #31,d0    ; Modulo 32
 move.w d0,a
 and.w  #24,d0	  ; La meme animation toutes les 8 images
 lsr.w  #2,d0     ; a est un rel  virgule fixe
 add.w  d0,action
 bra FinSR

; MOVE ON BABY !!!
PasseTemps:
 clr.w b1
 move.w #22,action
 move.w a,d0       ; Gre les diffrentes animations
 addq  #1,d0
 and.w  #31,d0
 move.w d0,a
 and.w  #24,d0
 lsr.w  #2,d0
 add.w  d0,action
 bra FinSR
 
; BIG JUMP WITH A BUMPER
Bumper:
 move.w St,d3
 beq    Bump2
 subq   #1,d3
 move.w d3,St

 move.w #10,action  ;Bumper
 move.w a,d0
 addq   #1,d0
 and.w  #31,d0
 move.w d0,a
 and.w  #24,d0
 lsr.w  #2,d0
 add.w  d0,action

 move.w xj,d0
 move.w yj,d1
 sub.w  vith,d1
 cmp.w #112,d1
 bhi Bump3
 bsr GetTest
 cmp.b #1,d2
 beq  FinSR
Bump3:
 move.w d1,yj
 bra  FinSR
Bump2:
 lea  Tombe(PC),a6
 bra  Tombe

; Virtual Race
Propulseur:
 move.w Mx,d0
 bne PropSuite
 move.w My,d0
 beq ThatsAll
PropSuite:
 move.w xj,d0
 move.w yj,d1
 clr.w  sens
 add.w  Mx,d0
 cmp.b #224,d0
 bhi  SortiegdEntree
 bsr GetTest
 cmp.b #1,d2
 beq ThatsAll
 move.w d0,xj
 add.w  My,d1
 bsr GetTest
 cmp.b #1,d2
 beq ThatsAll
 move.w d1,yj
 bra    FinSR
ThatsAll:
; clr.w  Mx
; clr.w  My
 clr.l	Mx
 lea    Tombe(PC),a6
 bra 	Tombe
 
; ****************************************************
;
;		Tests : Fer a touch en d3,d4
;
; ****************************************************

; Tableau d'indirection
Test_table:	
	dc.w Rien-Test_table	; 0
	dc.w Rien-Test_table	; 1
	dc.w PlateForme-Test_table ; 2
	dc.w Monte-Test_table	; 3
	dc.w Bijou-Test_table	; 4
	dc.w OneUp-Test_table	; 5
	dc.w BumperG-Test_table	; 6
	dc.w Clef-Test_table	; 7
	dc.w Porte-Test_table	; 8
	dc.w Pic-Test_table	; 9
	dc.w Haut-Test_table	; 10
	dc.w Bas-Test_table	; 11
	dc.w Gauche-Test_table	; 12
	dc.w Droite-Test_table	; 13
	dc.w Arrive-Test_table	; 14
	dc.w Rien-Test_table	; 15 -> Ennemi type 1
	dc.w Rien-Test_table	; 16 -> Ennemi type 2
	dc.w Rien-Test_table	; 17 -> Ennemi type 2

SpriteADR
	dc.l SpriteHor  ; 0
	dc.l SpriteVert ; 1
	dc.l SpriteRien ; 2

Rien:	rts
 
PlateForme:
	movem.l d3-d4,-(a7)
   	and.w   #$FFF0,d4
	sub.w   #16,d4
	move.l  d4,d3
	move.w	yj,d4
	eor.w	d3,d4
	and.w   #$FFFC,d4
	bne.s	PlateFormeSuite
 	move.w 	d3,yj
PFEntry:
	btst.b #3,keystat
	bne.s	PFMar1
	move.w Hauteur,d3
	move.w d3,St ; HAUTEUR_SAUT
	Lea  Saut(PC),a6
	bra.s	PlateFormeSuite
PFMar1:
	cmp.b #255,keystat
	bne.s	PFMar2
	clr.w action ; DEBOUT
	bra.s	PlateFormeSuite
PFMar2:
	move.w #2,action ; MARCHE
	move.w a,d0      ; Gre les diffrentes animations
	addq   #1,d0
	and.w  #31,d0    ; Modulo 32
	move.w d0,a
	and.w  #24,d0	  ; La meme animation toutes les 8 images
	lsr.w  #2,d0
	add.w  d0,action
PlateFormeSuite:
	movem.l (a7)+,d3-d4
	rts

Monte:
	movem.l d3-d4,-(a7)
   	and.w   #$FFF0,d4
	sub.w   #16,d4
	move.w  d4,yj
	bra.s	PFEntry
	
Bijou:
	movem.l d0-d2/a0,-(a7)
	addq.w	#1,Bj
BijouClear:
	move.w  d3,d0
	move.w  d4,d1
	and.w 	#$FFF0,d0
	and.w	#$FFF0,d1
	moveq	#0,d2
	bsr 	Ecriture
	lea     EffacerADR(PC),a0
	move.w  EffacerDecor,d2
	addq.w   #1,EffacerDecor
	lsl.l   #2,d2
	adda.l  d2,a0
 	move.w  d0,(a0)+
	move.w  d1,(a0)+
	bsr Statut
	movem.l (a7)+,d0-d2/a0
	rts

OneUp:
	movem.l d0-d2/a0,-(a7)
	addq.w 	#1,Vi
	bra.s	BijouClear
Clef:
	movem.l d0-d2/a0,-(a7)
	addq.w	#1,Cf
	bra.s	BijouClear
Porte:
 	movem.l d0-d2/a0,-(a7)
	move.w  Cf,d0
 	beq 	NoPass
	subq    #1,d0
	MOVE.w  d0,Cf
	bra.s	BijouClear
NoPass: 
	move.w xj,d0
	move.w yj,d1
	btst.b #4,keystat
	bne.s	NoLeftNP
	add.w  vith,d0
	move.w d0,xj
	bra.s	SuiteActNP
NoLeftNP:
	btst.b #6,keystat
	bne.s	SuiteActNP1
	sub.w  vith,d0
	move.w d0,xj
	bra.s	SuiteActNP
SuiteActNP1:
	sub.w  vith,d1
	move.w d1,yj
SuiteActNP:
	movem.l (a7)+,d0-d2/a0
	rts

BumperG:
	move.l d4,-(a7)
	and.w #$000F,d4
	eor.w #$000F,d4
	bne.s	BumperGOK
	lea    Bumper(PC),a6 ; Adresse action
	move.W Hauteur,d3
	lsl.w  #1,d3
	move.w d3,St	     ; Puissance Bumper
BumperGOK:
	move.l (a7)+,d4
	rts

Pic:
	movem.l d3-d4,-(a7)
	and.w #$000F,d4
	eor.w #$000F,d4
	bne.s	\no
	bsr.s	Touche
\no	movem.l (a7)+,d3-d4
	rts

Touche:
	clr.w  d4
	move.w v,d3
	bne.s	PicSort
	move.w Bj,d3
	beq.s	PicMort
	cmp.w  Diff,d3
	bhi.s	PicDecremente
	clr.w  d3
	bra.s	PicFin
PicDecremente:
	sub.w  Diff,d3
 	bra.s	PicFin
PicMort:
	clr.w  d3
	lea    Sortie(PC),a5
	move.w #1,d4
PicFin:
	move.w d3,Bj
	move.w Diff2,d3
	move.W d3,v     ; Dure
	bsr	Statut
	bsr	FlashScreen
PicSort:
	rts

Haut:	
	movem.l d0-d1,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	add.w  d0,d0
	neg.w  d0
	move.w d0,My
	move.w #36,d0
	move.w d0,action
	movem.l (a7)+,d0-d1
	rts

Bas:	
	move.l d0,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	add.w	d0,d0
	move.w d0,My
	move.w #37,d0
	move.w d0,action
	move.l (a7)+,d0
	rts

Gauche:
	movem.l d0-d1,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	add.w	d0,d0
	neg.w	d0
	move.w d0,Mx
	move.w #35,action
	movem.l (a7)+,d0-d1
	rts

Droite:
	move.l d0,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	add.w	d0,d0
	move.w d0,Mx
	move.w #34,action
	move.l (a7)+,d0
	rts
	
Arrive:
	move.w #255,xn
	bra	Sortie	; ?

SpriteHor:
	movem.l d0-d4/a0-a2,-(a7)
	move.w  6(a0),d0
	move.w  8(a0),d1
	moveq	#0,d3
	move.b  11(a0),d3
	beq.s	SpDroi
	addq.w	#1,d0
	bra.s	SpSuite
SpDroi:	subq.w	#1,d0
SpSuite:
	cmp.b   #224,d0
	bhi.s	SpChg
SpUni:
	bsr	GetTest
	cmp.b	#1,d2
	beq.s 	SpChg
	move.w  d0,6(a0)
	move.W  d1,8(a0)
	bra.s	SpSui2
SpChg:	eor.b   #1,d3
	move.b  d3,11(a0)
SpSui2:	
	move.w xj,d2
	sub.w  #15,d2
	cmp.w  d2,d0
	blt    NoTuch
	add.w  #30,d2
	cmp.w  d2,d0
	bgt    NoTuch

	move.w yj,d2
	sub.w  #15,d2
	cmp.w  d2,d1
	blt    NoTuch
	add.w  #30,d2
	cmp.w  d2,d1
	bgt    NoTuch

	cmp.W yj,d1
	bhi.s	FerTuch
	move.l a0,-(a7)
	bsr	Touche
	move.l (a7)+,a0
	cmp.w #1,d4
	beq	Mort
	bra	NoTuch

FerTuch:
	move.w	14(a0),d0
	bne	NoTuchBefore

	subq.w	#1,NbrSprite
	move.w	2(a0),d3
	move.w	4(a0),d4
	moveq	#0,d2
	bsr	Ecriture
	move.l	a0,a2		; Source
	lea	16(a0),a1	; Destination
	move.l	sprite_back_store,d0
	sub.l	a0,d0
	sub.l	#16,d0		; How many ?
	lsr.l	#2,d0	; LongWords = 4 * Bytes
\DelBoucle:
	move.l	(a1)+,(a2)+
	dbra	d0,\DelBoucle
	movem.l	(a7)+,d0-d4/a0-a2
	bra	RetourSansInc

NoTuchBefore:
	sub.w	#50,d0
	move.w	d0,14(a0)
	move.w	Hauteur(Pc),St ; HAUTEUR_SAUT
	Lea	Saut(PC),a6
NoTuch:
	move.w 12(a0),d0  ; Gre les diffrentes animations
	addq   #1,d0
	and.w  #31,d0     ; Modulo 32
	move.w d0,12(a0)
	and.w  #24,d0	  ; La meme animation toutes les 8 images
	lsr.w  #2,d0
	add.b  11(a0),d0
	add.b  1(a0),d0
	move.b d0,10(a0)
	movem.l (a7)+,d0-d4/a0-a2
	bra	Retour

Mort:	movem.l (a7)+,d0-d4/a0-a2
	bra	Sortie		; ?

SpriteVert:
	movem.l d0-d4/a0-a2,-(a7)
	move.w  6(a0),d0
	move.w  8(a0),d1
	moveq	#0,d3
	move.b  11(a0),d3
	beq	SpDown
	addq    #1,d1
	bra     SpSuitV
SpDown:	subq   #1,d1
SpSuitV:
	cmp.b   #112,d1
	bhi	SpChg
	bra 	SpUni

SpriteRien:
	movem.l d0-d4/a0-a2,-(a7)
	move.w  6(a0),d0
	move.w  8(a0),d1
	moveq	#0,d3
	move.b  11(a0),d3
	bra 	SpUni

; ****************************************************
;
;                Routines
;
; *****************************************************

; A refaire integralement !

; Print the screen
PutDecor:
 movem.l d0-d6/a0-a5,-(a7)
 moveq	#0,d2
 move.l level,a3
 move.l leveltest,a5
 move.l sprite_adr,a4
 move.l	#7,d4
 moveq	#0,d1
LoopDecor1:
 moveq	#0,d0
 moveq	#14,d3
LoopDecor:
 move.b (a3)+,d2 
 move.b (a5)+,d5
 cmp.b  #14,d5		; SpriteTab
 bhi    NewSprite
SpriteSuite:
 bsr PutSprite
 add.l  #16,d0
 dbra d3,LoopDecor
 add.l  #16,d1
 dbra d4,LoopDecor1

 movem.l (a7)+,d0-d6/a0-a5
 rts

; A sprite is somewhere : we have to save it .
NewSprite:
	move.w	NbrSprite(Pc),d6
	cmp.w	MaxSprite(Pc),d6
	beq.s	SpriteForget
	addq.w	#1,d6
	move.w d6,NbrSprite
	sub.b  #15,d5		; SpriteTab  partir de ___ ce sont des sprites
	move.b d5,(a4)+
	move.b d2,(a4)+
	move.w d0,(a4)+
	move.w d1,(a4)+
	move.w d0,(a4)+
	move.w d1,(a4)+
	move.b d2,(a4)+
	clr.b  (a4)+
	clr.w  (a4)+
	move.w #1000,(a4)+
SpriteForget:
	moveq	#0,d2
	bra	SpriteSuite
 
GetTest:	; Teste si le perso en D0,D1 est sur un bloc
		; Retourne D2 = 1 (Pas pos), AUTRE sinon
 movem.l d3-d4,-(a7)

 move.l d0,d3
 move.l d1,d4
 bsr Lecture
 cmp.w #1,d2
 beq TestFaux

 add.l #15,d3
 bsr Lecture
 cmp.w #1,d2
 beq TestFaux

 add.l #15,d4
 bsr Lecture
 cmp.w #1,d2
 beq TestFaux

 sub.l #15,d3
 bsr Lecture
TestFaux:
 movem.l (a7)+,d3-d4
 rts

; Lecture Data du niveau au coordones d3,d4
; Return D2
Lecture:
 movem.l d3-d4/a0,-(a7)
 move.l    leveltest,a0
 lsr.l  #4,d3
 lsr.l  #4,d4
 sub.l  d4,d3
 lsl.l  #4,d4
 add.l  d4,d3
 moveq	#0,d2
 move.b 0(a0,d3),d2
 movem.l (a7)+,d3-d4/a0
 rts

; Ecriture Data du niveau au coordones d3,d4 
; Source d2.b -> Test  d2.w / 2^8 -> Graph
Ecriture:
 movem.l d3-d4/a0-a1,-(a7)
 move.L    leveltest,a0
 move.l    level,a1
 lsr.l  #4,d3
 lsr.l  #4,d4
 sub.l  d4,d3
 lsl.l  #4,d4
 add.l  d4,d3
 adda.l d3,a0
 adda.l d3,a1
 move.b d2,(a0)
 lsr.l  #8,d2
 move.b d2,(a1)
 movem.l (a7)+,d3-d4/a0-a1
 rts

GetLevelADR:
 movem.l d0/a0,-(a7)
 move.l  level_adr,a0
 moveq	#0,d0
 move.w  yn,d0
 mulu    #8,d0     ; Taille du grand niveau en Xn (0 -> MaxXn) => MaxXn+1
 add.w   xn,d0	   ; 0..7
 mulu    #240,d0   ; Et on multiplie par la taille d'un niveau : 15*8*2 Bytes
 add.l   d0,a0
 move.l  a0,level
 add.l   #15*8,a0  ; On ajoute un demi niveau !
 move.l  a0,leveltest
 movem.l (a7)+,d0/a0
 rts

; Put the number d2.l at coordinates ( d3.w = X, d4.w = Y) with 4 digits
; Destroy : no registers
put_number:
Putnumber:
PutNumber:
Put_number:
	movem.l d0-d2/a0-a1,-(a7)
	moveq	#4,d1

	lea	(strend+9),a0	; Load tempory storage string adress
	clr.b	(a0)		; for DrawStrXY
\Rep1:
	divu	#10,d2		; d3 / 10
	swap	d2		; Work on the rest
	addi.b	#'0',d2		; Add 48 to the rest of the division
	move.b	d2,-(a0)	; Save the rest
	subq.w	#1,d1		
	beq.s	\CSDone		; to avoid a crash if the number has too many digits
	clr.w	d2		; Clear the rest
	swap	d2		; New number D3.l = Int(D3.l / 10)
	bne.s	\Rep1		; No need of 'tst' because 'swap' does it
	tst.w  d1
	beq.s	\CSDone	
	subq.w	#1,d1		; For dbf
\Rep2:	move.b	#' ',-(a0)	; Complete par des 0
	dbra.s	d1,\Rep2
\CSDone:
	move.w	d3,d0
	move.l	d4,d1
	move.l	genlib::window,a1
	jsr	genlib::put_large_string
\Stat1:
	movem.l (a7)+,d0-d2/a0-a1
	rts

; Affiche le statut du personnage
Statut:
	movem.l d0-d2/a0-a1,-(a7)
	
 	moveq	#0,d0
	moveq	#0,d1
	move.l	genlib::window,a1
	lea	statut(Pc),a0
	jsr	genlib::put_large_string

	moveq	#0,d4
	move.w  Bj(Pc),d2
	moveq	#50,d3
	bsr.s	Put_number

	move.w  Vi(Pc),d2
	moveq	#64,d3
	bsr.s	Put_number

	move.w  Cf(Pc),d2
	moveq	#104,d3
	bsr.s	Put_number

	movem.l (a7)+,d0-d2/a0-a1
	rts

FlashScreen:
	movem.l d0-d1/a0,-(a7)
	moveq	 #5,d1
\Scr:
	move.w  #960*2-1,d0
	move.l	 DScreen(Pc),a0
\Rep:	not.l  (a0)+
	dbra   d0,\Rep
	bsr.s	Double_buffer
	dbra   d1,\Scr
	movem.l (a7)+,d0-d1/a0
	rts

Double_buffer:
	movem.l	d0-d1,-(a7)
	move.w	Tps(Pc),d1
	move.l	Screen1(Pc,d1.w),d0
	jsr	genlib::set_dscreen_int
	eor.w	#4,d1
	move.l	Screen1(Pc,d1.w),d0
	move.l	d0,DScreen
	jsr	genlib::set_dscreen_function
	move.w	d1,Tps
	movem.l	(a7)+,d0-d1
\loop:
	cmp.l	#2,genlib::timer
	bls.s	\loop
	clr.l	genlib::timer
	rts

Tps	dc.w	0
Screen1	dc.l	0
Screen2	dc.l	0
DScreen	dc.l	0

xj:	dc.w 0
yj:	dc.w 0
vith:	dc.w 1  ; Vitesse de dplacement =2^p1
Hauteur:
	dc.w 40 ; Hauteur d'un saut

Bj	dc.w 0
Cf	dc.w 0
Vi	dc.w 0

Diff	dc.w 30   ; Difficulte du jeu
Diff2	dc.w 300  ; 	"

strend	ds.b	10

;************************************
;
;		 Sprites datas
;
;************************************

NbrSprite	dc.w 0
ExNbrSprite	dc.w 0
MaxSprite	dc.w 8
sprite_handle	dc.w 0
sprite_adr	dc.l 0
sprite_back_store
		dc.l 0
SpriteAdrTemp	dc.l 0
Sprite		INCBIN 	sprite.bin


Gfx_adr		dc.l	0
Test_adr	dc.l	0

SubLevel	dc.w  0
fernand  	INCBIN fernand.bin	; Perso animation
decor		dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; Le 'dcor' vide
		INCBIN decor.bin
Level		INCBIN	"LevelFr3.P92"

statut		dc.b "POWER :           LIFE:          KEYS:",0
_comment	dc.b "Fernando 3 v3.0",0


 end
