;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;
; *****************************************************************
; *****************************************************************
; ***								***
; ***	         	Big level				***
; ***								***
; *****************************************************************
; *****************************************************************

; Probleme :
; + MultiJouer Cooperation ?

BeginBigLevel:
	move.l	SpriteADR(a6),a4	; Get adress of the buffer of sprite
	move.l	a4,-(a7)		; Save it
	add.w	#BIG_LVL_SIZE,a4	; Make the buffer
	move.l	a4,SpriteADR(a6)	
	move.l	a4,SpriteADREnd(a6)	; Top of sprite buffer
	move.w	(a1)+,BIG_LVL_SX(a4)	; Save Size X
	move.w	(a1)+,BIG_LVL_SY(a4)	; Save Size Y
	clr.w	BIG_LVL_X(a4)		; Level Current X=0
	clr.w	BIG_LVL_Y(a4)		; Level Current Y=0
	move.b	#START_BIG_LEVEL,Mort(a6)
\Big_Loop:
	move.w	BIG_LVL_Y(a4),d0
	move.w	BIG_LVL_SX(a4),d1
	addq.w	#1,d1		; 0 is size 1 so i need to add 1
	mulu.w	d1,d0
	add.w	BIG_LVL_X(a4),d0
	add.w	d6,d0			; File to extract
	addq.w	#1,d0			; D0 = No_Big + 1 + X_W + Size_X * Y_W
	move.l	a5,a0			; Adress of compressed data
	jsr	pk92lib::Extract
	tst.b	d0
	bne.s	\Error_Memory
	movem.l d6/a4-a5,-(a7)		; Save registers on the stack
	move.w d1,-(a7)			; Save the handle on the stack
	tst.w	(a1)+			; test the type of the level
	bne.s	\Skip
	bsr	BeginLevel
	bra.s	\Ok
\Skip:	move.b	#LEVEL_COMPLETED,Mort(a6)	; Au cas o ...
\Ok:	jsr	tios::HeapFree		; Destroy the handle of the level file
	addq.l	#2,a7
	movem.l (a7)+,d6/a4-a5		; Restore registers

	move.b	Mort(a6),d3
	bne.s	\No_Dead
	tst.w	Vi(a6)
	beq.s	\Exit
	move.b	#BIG_LEVEL,Mort(a6)	; Set for no reinit sprite table and data
	clr.w	Bj(a6)			; Restart at ckek point : no power !
	bra.s	\Big_Loop
\No_Dead:
	cmp.b	#BIG_LEVEL,d3
	beq.s	\Big_Loop
	cmp.b	#LEVEL_COMPLETED,d3
	bne.s	\Exit
	move.b	#JUMP_LEVEL,Mort(a6)	; Skip the world
	move.w	BIG_LVL_SY(a4),d5
	move.w	BIG_LVL_SX(a4),d4
	addq.w	#1,d5		; 0 is size 1 so i need to add 1
	addq.w	#1,d4		; 0 is size 1 so i need to add 1
	mulu.w	d4,d5		; Size_X * Size_Y
	add.w	d6,d5		; Add num of world
	addq.w	#1,d5		; Skip big_Level file
	bra.s	\Exit
\Error_Memory:
	move.b	#MEMORY,Mort(a6)
\Exit:
	move.l	(a7)+,SpriteADR(a6)	; restore sprite buffer
	rts

Sprite_Init_Big_Level:
	move.w	#22,No(a1)
	move.l	SpriteADR(a6),a0
	move.w	StartX(a6),BIG_LEVEL_START_X(a0)
	move.w	StartY(a6),BIG_LEVEL_START_Y(a0)
	addq.l	#2,a1
	rts

Sprite_Big_Level:
	move.l	SpriteADR(a6),a0
	cmp.w	#5,d6
	bhi.s	\NoLeft
	tst.w	BIG_LVL_X(a0)
	beq.s	\NoLeft
	subq.w	#1,BIG_LVL_X(a0)	; Change sub-level
	move.w	#(4096-32),d6		; Update X_Fer data
	bra.s	\End
\NoLeft:
	cmp.w	#(4096-16-5),d6
	bls.s	\NoRight
	move.w	BIG_LVL_X(a0),d0
	cmp.w	BIG_LVL_SX(a0),d0
	beq.s	\NoRight
	addq.w	#1,BIG_LVL_X(a0)
	moveq	#16,d6
	bra.s	\End
\NoRight:
	cmp.w	#5,d7
	bhi.s	\NoUp
	tst.w	BIG_LVL_Y(a0)
	beq.s	\NoUp
	subq.w	#1,BIG_LVL_Y(a0)
	move.w	#(1024-64),d7
	bra.s	\End
\NoUp:
	cmp.w	#(1024-32),d7
	bls.s	\NoDown
	move.w	BIG_LVL_Y(a0),d0
	cmp.w	BIG_LVL_SY(a0),d0
	beq.s	\NoDown
	addq.w	#1,BIG_LVL_Y(a0)
	moveq	#16,d7
\End:	move.b	#BIG_LEVEL,Mort(a6)
	move.w	d6,BIG_LEVEL_START_X(a0)
	move.w	d7,BIG_LEVEL_START_Y(a0)
\NoDown:
	addq.l	#BIG_LVL_END,a5	; Next sprite
	rts

