;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***                      CURRENT RELEASE : 0.50                          ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;
;
;****************************************************************************
;***                                                                      ***
;***                      	REGISTERS	                          ***
;***                                                                      ***
;****************************************************************************
; d0-d4 : Used as you want
; d5.l  : reserved
; d6.w  : X_Fernando
; d7.w  : Y_Fernando
; a0-a3 : Used as you want
; a4.l  : reserved
; a5.l  : Current sprite
; a6.l  : Adress of the variables
; a7.l  : Stack



; Include header files

	include	tios.h		; ROM routines
	include pk92lib.h	; Extract routine
	include hexlib.h	; putHex / PutBin routine

	include "sprite.h"		; Some data : most of them about sprite structure
	include "options.h"		; Directives of compilation

	xdef	_library
	xdef	fer3c@0000
	xdef	fer3c@0001
	xdef	fer3c@0002
	xdef	fer3c@0003
	xdef	fer3c@0004
	xdef	fer3c@0005
	xdef	fer3c@0006
	xdef	fer3c@0007
	xdef	fer3c@0008
	xdef	fer3c@0009
	xdef	fer3c@000A
	xdef	fer3c@000B
	xdef	fer3c@000C
	xdef	fer3c@000D
	xdef	fer3c@000E
	xdef	fer3c@000F
	xdef	fer3c@0010

	include "data.h"		; Include the data

;
;****************************************************************************
;***                                                                      ***
;***            		Starting Fer3c	.		  	  ***
;***                                                                      ***
;****************************************************************************

fer3c@0000:
Starting_Point:
 lea	fer3c@0001(PC),a6	; Set a6 to variable acces.
 move.l	a0,LevelADR(a6)		; Save ADR of the world-file...

; If we know the Handle of the I/O we will use it, else we will use a buffer
 ifeq	HANDLEOK-1
 moveq	#(4*HANDLEIO),d0	; Set Sprite-Buffer : I/O Screen
 move.l	tios::Heap,a1		; Insert tios::DEREF Macro
 move.l	0(a1,d0.w),a1		; and optimize it to be shorter...
 addq.l	#4,a1			; Find Adress of I/O Screen
 endif

 ifeq	HANDLEOK
 pea	(SPRITE_BUFFER+2*MAX_SPRITE_SIZE).w
 jsr	tios::HeapAllocHigh		; Allocate memory for sprite-buffer
 addq.l	#4,a7
 tst.w	d0
 bne.s	\Ok
 move.w	#670,-(a7)
 jsr	tios::ERD_dialog	; Woah ! Une boite !
 addq.l	#2,a7			; Print Error : Memory
 rts
\Ok:
 move.w	d0,-(a7)		; we will destroy the buffer before quitting
 tios::DEREF  d0,a1
 endif

 move.l a1,SpriteADR(a6)		; Save adress of sprite-buffer
 lea	SPRITE_BUFFER(a1),a1		; Adr of the end of the buffer
 move.l	a1,(SpriteInitEndBuffer+2-fer3c@0001)(a6)
					; Save here ! (Immediate value)

 move.w	#1,Turbo(a6)		; No turbo mode
 lea	Vide_Str(PC),a0
 move.l	a0,(Intro_Text+6-fer3c@0001)(a6)

; bra	StartDebugHere		; For debug use only

Intro:
 moveq	#5,d7
 lea	Intro_Text(PC),a3
 bsr	DrawText	; Show intro-menu-text

 ifeq	LINK_MODE-1
  clr.b	Link(a6)	; No link
 endif

Waiting_Loop:
 moveq	#0,d3
 move.b Frame_Time(a6),d3
 moveq	#FRAME_Y,d2
 bsr	PutNumber	; Put the speed of the game on the screen

 bsr	GetKey		; Read one key

 cmp.w #264,d0		; ESC
 bne.s \skip

; Destroy the reserved Handle (for sprite) if we have create it
 ifeq	HANDLEOK
 jsr	tios::HeapFree	; Free allocated memory
 addq.l	#2,a7	
 endif
 clr.l	ExecAddOnADR(a6) ; Clear the add-on.
 clr.l	InitAddOnADR(a6)
 move.b #$B2,($600017)	; Restore processor's clock
 rts			; Exit fernando 3-c

\skip:
 cmp.w	#CHEAT_KEY,d0	; Cheat code 2 * more speed !!!!!
 bne.s	\Skipc
 move.w	#2,Turbo(a6)	; Set Turbo to 2
 lea	Turbo_Str(PC),a0
 move.l	a0,(Intro_Text+6-fer3c@0001)(a6)
 bra.s	Intro

\Skipc:
 cmp.w	#CHEAT_KEY2,d0	; Cheat code 4 * more speed !!!!!
 bne.s	\Skip2
 move.w	#4,Turbo(a6)	; Set Turbo to 4 ; Warning : it makes some bugs !
 lea	OC_Turbo_Str(PC),a0
 move.l	a0,(Intro_Text+6-fer3c@0001)(a6)
 bra.s	Intro

\Skip2:
 cmp.w #KEY_RIGHT,d0		; Right ?
 bne.s	\Skip2a
 addq.b #1,Frame_Time(a6)	; Speed - 1
 bra.s	Waiting_Loop

\Skip2a:
 cmp.w #KEY_LEFT,d0		; Left ?
 bne.s	\Skip2b
 subq.b #1,Frame_Time(a6)	; Speed + 1
 bra	Waiting_Loop

\Skip2b:
 cmp.w #268,d0
 bne.s \NoF1
 move.l	#(EASY_DEC*65536+EASY_INV),Diff(a6) ; Easy Mode
 bra.s \LetsGo

\NoF1:
 cmp.w #269,d0
 bne.s \NoF2
 move.l	#(NORMAL_DEC*65536+NORMAL_INV),Diff(a6)	; Normal Mode
 bra.s \LetsGo

\NoF2:
 cmp.w #270,d0
 bne.s	\NoF3
 move.l	#(HARD_DEC*65536+HARD_INV),Diff(a6)	; Hard Mode
 bra.s \LetsGo

\NoF3:
 ifeq	LINK_MODE-1
 cmp.w	#271,d0
 bne.s	\NoF4
 bsr	Link_mode
 bra	Intro
 endif

\NoF4:
 cmp.w	#272,d0
 bne	Waiting_Loop
 lea	Save(a6),a0	; Load a game
 move.l	LevelADR(a6),a1
 move.l	a1,a5		; Copy to a5
 cmp.w	(a0)+,(a1)+
 bne	Waiting_Loop	; Not the same number of levels : Quit
 moveq	#9,d0
\Cmp_Loop:
 cmpm.b	(a1)+,(a0)+	; Compare the current level to the saved-level
 bne	Waiting_Loop	; Not the same : quit !
 lea	254(a1),a1
 dbf.s	d0,\Cmp_Loop

; Ok it's validate,
 move.w	(a0)+,Vi(a6)	; Reading Life
			; a5 : the adress of the level-file.
 move.l	a5,-(a7)	; Save ADR of Level File
 move.w (a5)+,d7	; Read Number of Levels
 move.w	(a0)+,d6	; Read current Level
 bra.s	StartFile

\LetsGo:
 bsr	Select_Player	; Select how many players : 1, 2 or ...
 bne	Intro

StartDebugHere:
 move.w #3,Vi(a6)	; Set Life to 3
 move.l	LevelADR(a6),a5	; Set a5 to the adress of the compressed world
 move.l	a5,-(a7)	; Save these adress on the stack
 move.w (a5)+,d7	; Read the numbers of levels
 moveq	#1,d6		; Set current level to 1 (i.e. d6)

StartFile:
; Extraction du niveau
 move.w d6,d0			; File d0
 move.l	a5,a0			; Adr a0
 jsr    pk92lib::Extract	; Extract the level using pk92lib
 tst.b	d0			; Ok ?
 bne	Memory0			; Not enought memory !
 ori.w	#$8000,-2(a1)		; Lock Handle (Even on 92 !)
 
 movem.l d6-d7/a5-a6,-(a7)		; Save registers on the stack
 move.w d1,-(a7)			; Save the handle on the stack
 move.l SpriteADR(a6),SpriteADREnd(a6)	; ReInit Sprite Table
 move.b #LEVEL_COMPLETED,Mort(a6)	; Level completed (if not, it will change)
				; The adress is in a1 and the handle in D1.
 move.w	(a1)+,d2		; Get the type of the level in d2.w
 cmp.w	#MAX_TYPE_LEVEL,d2	; Level-Type > MaxLevelType ?
 bls.s	\Ok			; So it's a program !
 move.w (a7),d0			; Well, if it is Fargo, the arg is pushed on the stack, if preos, the arg is in d0
 jsr	kernel::Exec		; Execution : the handle is on the stack.
 bra.s	\Skip
\Ok:			; Not a program !
 move.w #$0700,d0	; Hight priority level : Set all int off
 trap	#1
 move.w	Type_Code_Table(pc,d2.w),d0
 jsr	Type_Code_Table(pc,d0.w)	; Exec the level
 moveq	#0,d0		; Restore all auto-int.
 trap	#1
\Skip:
 jsr	tios::HeapFree		; Destroy the handle of the level file
 addq.l	#2,a7
 movem.l (a7)+,d6-d7/a5-a6	; Restore registers

 
; Clear the screen and set Font as GRAS
 bsr	Zap_Screen
 SetFont	GRAS

; Test
 move.b	Mort(a6),d3
 cmpi.b #QUICK_EXIT,d3
 beq.s	SaveIt

; Vie >0 ? Not, Game Over
 tst.w	Vi(a6)
 beq	GameOver

 bra.s	NoSave

Type_Code_Table:
	dc.w	BeginLevel-Type_Code_Table	; 0
	dc.w	BeginBoss-Type_Code_Table	; 2
	dc.w	JumpLevel-Type_Code_Table	; 4
	dc.w	JumpKey-Type_Code_Table		; 6
	dc.w	BeginBigLevel-Type_Code_Table	; 8


SaveIt:
 WriteStr #END_X,#END_Y,#4,Save_Str	; Write "Save ?"
 bsr	GetKey		; Wait for a key.
 cmp.w	#13,d0		; Enter ?
 bne.s	ExitQuick	; No, skip
 lea	Save(a6),a0	; yes, save the level !
 move.w	d7,(a0)+	; Save the number of levels
 move.l	a5,a1
 moveq	#9,d0
\Cmp_Loop:
 move.b	(a1)+,(a0)+	; Save some data about the world
 lea	254(a1),a1
 dbf.s	d0,\Cmp_Loop
 move.w	Vi(a6),(a0)+	; Save life and
 move.w	d6,(a0)+	; Save No-level
 bra.s	ExitQuick

NoSave:
 cmpi.b	#MEMORY,d3
 beq.s	Memory		; Error memory ?

 cmpi.b	#JUMP_LEVEL,d3
 bne.s	\NoJump		; Set level to a new value ?
 move.w	d5,d6		; Go to d5 !
 cmp.w	d6,d7		; LevlNo = LevelMax ?
 blt.s	Thatsall
 bra	StartFile
\NoJump:
 cmpi.b	#LEVEL_COMPLETED,d3
 bne	StartFile 	; We restart this level.

NextLevel:
 cmp.w	d6,d7		; LevlNo = LevelMax ?
 ble.s	Thatsall
 addq.w	#1,d6		; LevlNo +=1
 bra	StartFile	; Next Level

Memory0:
 bsr	Zap_Screen
Memory:
 move.w	#4,-(a7)
 pea	Memory_Str(PC)
 bra.s	Show_The_Text	; Write "Memory"

Thatsall:
 move.w	#4,-(a7)
 pea	Thats_all_Str(PC)
 bra.s	Show_The_Text	; Write "The end"

GameOver:
 move.w	#4,-(a7)
 pea	Game_Over_Str(PC)
Show_The_Text:		; Write "Game over"
 move.w	#END_Y,-(a7)
 move.w	#END_X,-(a7)
 jsr	tios::DrawStrXY	
 lea	10(a7),a7

; Back to intro
ExitPK92:
 bsr	WaitForAllKey	; Wait until all keys.

ExitQuick:
 move.l (a7)+,LevelADR(a6)	; Restore the adress of the world

 bra	Intro		; Back to the intro

Init2ndScreen:		; Init a new screen : D0 = adress of it
 addq.l #7,d0
 lsr.l  #3,d0		; To have a 8x adress
 move.w d0,Table+2*0(a6)	; This adress must be a x 8
 lsl.l  #3,d0
 move.l	d0,(SecondScreenIV+2-fer3c@0001)(a6)	; Save this Adress
 move.l #LCD_MEM,d0
 move.l d0,Screen(a6)
 lsr.l  #3,d0
 move.w d0,Table+2*1(a6)
 rts















; *********************************************************************
;
;			LEVELS		FILES
;
; *********************************************************************

JumpKey:
	tst.w	Cf(a6)
	bne.s	JumpRts
JumpLevel:
	move.b	#JUMP_LEVEL,Mort(a6)
	move.w	(a1),d5
JumpRts:
	rts

fer3c@000E:
BeginLevel:
; Try
 cmpa.l #(VIRTUAL_SIZE+SCREEN_SIZE+1000),a7
 bls	ExitLevel	; La pile est surcharge : on quitte immdiatement !
			; User Stack : $0120

; Set the 2nd Screen
 lea	-(SCREEN_SIZE+8)(a7),a7	; On stocke le second cran dans la pile
 move.l a7,d0			; Push Screen2
 bsr	Init2ndScreen

; Set the virtual screen
 lea	-(VIRTUAL_SIZE)(a7),a7	; On stocke l'cran virtuel dans la pile
 move.l a7,VirtualScreen(a6)	; Push VirtualScreen

; Set the level file
 clr.w  d0
 move.b (a1)+,d0
 lsl.w  #5,d0
 move.w d0,StartX(a6)		; Read and set the start position
 clr.w  d1
 move.b (a1)+,d1
 lsl.w  #5,d1
 move.w d1,StartY(a6)		; Read and set the Y start position

 move.l a1,LevelADR(a6)		; Save adress of Gfx-table
 lea	(128*32)(a1),a1
 move.l a1,LevelTestADR(a6)	; Save adress of test-table

; Extract the graph file.
 move.l	a5,a0		; A5 -> Packered Level
 clr.w	d0		; File No 0
 jsr     pk92lib::Extract
 tst.b	d0		; Is  there enought memory left ?
 bne	Overflow	; No Enought Mem
 ori.w	#$8000,-2(a1)	; Lock it (Even on 92)
 move.l	a1,GraphADR(a6)	; Save Adresse 

; Compte les Bijous et les vies du niveau 
; How many power and life in the level ?
 clr.w d2
 clr.w d3
 move.w	#4095,d0
 move.l LevelTestADR(a6),a0
\Loop0:
 move.b	(a0)+,d1
 cmpi.b	#4,d1		; Power ?
 bne.s	\Skip0
 addq.w	#1,d2
\Skip0:
 cmpi.b	#5,d1		; One-Up ?
 bne.s	\Skip1
 addq.w	#1,d3
\Skip1:
 cmpi.b	#15,d1		; Hyper Power ?
 bne.s	\Skip2
 addi.w	#8,d2
\Skip2:
 dbf.s	d0,\Loop0

 move.w d2,ComptBj(a6)	; Save the number of powers
 move.w d3,ComptVi(a6)	; save the number of lifes

; Big Level test
 cmp.b	#BIG_LEVEL,Mort(a6)
 beq.s	\NoInit

; Reset variables
 clr.l  Bj(a6)		; Clear Bj, BoutOn and other 
 clr.l  BoutON(a6)	; "
 move.w #100,v(a6)	; Set invulnerable to 100 frames
 ifeq	LOOK-1
  clr.l	Look_X(a6)	; Clear Look_X and Look_Y
 endif

 ifeq	AUTO_LOW-1
  clr.b	LowFlag(a6)	; Clear the low flag
 endif

 bsr	WaitForNotKey

 bsr	Init_Fernando	; Init Fernando

 ifeq	LINK_MODE-1
  tst.b	Link(a6)	; If we are in link-mode
  beq.s	\NoLink
  moveq	#20,d0
  bsr	SpriteInit	; Init sprite link !
\NoLink:
 endif

; Clear Time
 clr.l	Clock(a6)	; Clear the time

; Big Level test
 cmp.b	#START_BIG_LEVEL,Mort(a6)
 bne.s	\InitEnd
 moveq	#22,d0
 bsr	SpriteInit
 bra.s	\InitEnd
\NoInit:
 move.l	SpriteADR(a6),a0
 move.l	BIG_LEVEL_START_X(a0),Xj(a0)	; Restore Xj and Yj
\InitEnd:

 bsr	Statut		; Show variables

StartTeleportation:
 moveq	#6,d0
 move.w	StartX(a6),d1
 move.w	StartY(a6),d2
 bsr	SpriteInit	; Init explode

; UpDate Scroll Var
 move.w d1,d0
 move.w d2,d1
 bsr	UpDateScrollVar
 move.l	XsNew(a6),Xs(a6)

; refresh VirtualScreen
 move.w #4000,YsOld(a6)

; Set Mort = False
 move.b #OK,Mort(a6)

; Init all sprites in the screen : destroy a0, a5, d0, d1 & d2
 bsr	InitAllSprite

 bsr	WaitForNotKey

; MAIN LOOP :
; 1. Change the screen using the double buffer.
; 2. Set the processor's clock to 1 for wait
; 3. Draw the new screen (background only !)
; 4. Refresh the keys
; 5. Test some special keys like EXIT_KEY, PAUSE_KEY.
; 6. Refresh all the sprites.
; 6' Draw the stat if you pressed the STAT_KEY.
; 7. Refresh contrast if ON.
; 8. Refresh Free look if ON.
; 9. Wait for the processor's clock.
; 10. Refresh the coordinates of the scrolling.
; 11. Incremente the clock.
; 12. If Mort=OK, go to step 1.
Loop:

 bsr	ChangeScreen	; Change the current screen

 move.b #1,($600017)	; Set the processor' s clock to 1

 bsr	Scrolling	; Put the graphs of the levels on the current
			; screen

 bsr    GetKeyStat	; Read the keys
 Exit_Key_Test		; Exit Key ?
 bne.s	\skip
 move.b #QUICK_EXIT,Mort(a6) ; Quit the Main Loop
\skip:
 Pause_Key_Test
 bne.s	\skip2
 movem.l d0-d7/a0-a6,-(a7)	; Save registers
 trap #4			; Pause and turn off the calc
 movem.l (a7)+,d0-d7/a0-a6	; Restore registers
\skip2:
 
 bsr  SpriteGestion	; Gestion des sprites
			; Sprite move, draw, ...
 ifeq	CONTRAST-1
  bsr	Contrast
 endif
 ifeq	LOOK-1
  include "look.s"	; Look up, down ?
 endif
 PUT_STATUT
 ifeq	DEBUG-1
  move.b ($600017),Save_Freq(a6) ; Save current frequency
 endif

 ifeq	AUTO_LOW
 move.b Frame_Time(a6),d0	; Normal waiting for processor's clock.
\Wait:
 cmp.b	($600017),d0	; Wait for the processor's clock
 bhi.s	\Wait
 endif

 ifeq	AUTO_LOW-1
  include "auto_low.s"
 endif

 move.l	XsNew(a6),Xs(a6) ; UpDate Scroll Variables

 ifeq	DEBUG-1
 include "debug.s"
 endif

 ifeq	DEBUG-2
 moveq	#0,d0
 moveq	#Row_Key,d2
 lea	keystat(PC),a0
 moveq	#3,d1
\Loop:
 move.b	(a0)+,d0
 moveq	#10,d2
 moveq	#7,d4
 jsr	hexlib::put_bin	; Show Key pressed
 addq	#1,d1
 dbf	d2,\Loop
 endif

 moveq	#0,d0
 move.w	Turbo(a6),d0
 add.l	d0,Clock(a6)		; The time is incremented

 move.b	Mort(a6),d0
 cmpi.b #OK,d0
 beq	Loop		; If Mort = False, continue the main loop

; End of Main Loop

; Remove the low-flag if need.
 ifeq	AUTO_LOW-1
 tst.b	LowFlag(a6)
 beq.s	\NoRestoreTurbo
 clr.b	LowFlag(a6)	; Clear Low flag
 move.w	Turbo(a6),d1
 asr.w	#1,d1		; Turbo / 2
 move.w	d1,Turbo(a6)
\NoRestoreTurbo:
 endif

; Test special ends
 cmpi.b #TELEPORTATION,d0
 beq	StartTeleportation

 move.w	Table+2(a6),($600010)	; Restore correct Screen

 cmpi.b #LEVEL_COMPLETED,d0
 beq.s	LevelCompleted

 tst.b	d0
 bne.s	exit

; Go to game over | if link -<competition>-, restart level !
 ifeq	LINK_MODE-1
 move.l	SpriteADR(a6),a0
 move.w	StartX(a6),Xj(a0)
 move.w	StartY(a6),Yj(a0)	; Restart at last point
 tst.b	Link(a6)
 bne	StartTeleportation
 endif
 subq.w #1,Vi(a6)
 bra.s	exit

LevelCompleted:
 ifeq	LINK_MODE-1
 tst.b	Link(a6)
 bne.s	exit		; if competition, don't show 'Level completed' screen
 endif
 lea		Level_Completed_Text(PC),a3
 moveq		#5,d7
 bsr		DrawText
 move.w		Bj(a6),d3
 moveq		#LEVEL2_Y,d2
 bsr		PutNumber
 move.w		Coins(a6),d3
 moveq		#LEVEL5_Y,d2
 bsr		PutNumber
 move.w		ComptBj(a6),d3
 moveq		#SLASH_Y,d2
 bsr		PutNumber
 move.w		ComptVi(a6),d3
 moveq		#LEVEL3_Y,d2
 bsr		PutNumber
 move.l		Clock(a6),d3
 moveq		#LEVEL4_Y,d2
 bsr		PutNumber

 bsr		WaitForAllKey

exit:
 jsr	pk92lib::FreeMem	; Destroy the handle of the Graph File !

 bsr	WaitForNotKey

 lea (VIRTUAL_SIZE+SCREEN_SIZE+8)(a7),a7	; Pop Virtual Screen & 2nd Screen

ExitLevel:
 rts

Overflow:
 move.b	#MEMORY,Mort(a6)
 bra.s	exit










BeginBoss:
 ifne	BOSS_MODE
 include "Boss.s"
 endif
 rts

 ifne	BIG_LEVEL_MODE
 include "Big_Lvl.s"
 endif
 ifeq	BIG_LEVEL_MODE
Sprite_Init_Big_Level:		; Never call
Sprite_Big_Level:		; Never call
BeginBigLevel:
 move.b	#JUMP_LEVEL,Mort(a6)	; Skip the world
 move.w	(a1)+,d4
 move.w	(a1)+,d5
 addq.w	#1,d5		; 0 is size 1 so i need to add 1
 addq.w	#1,d4		; 0 is size 1 so i need to add 1
 mulu.w	d4,d5		; Size_X * Size_Y
 add.w	d6,d5		; Add num of world
 addq.w	#1,d5		; Skip big_Level file
 rts
 endif



; ************************************************************
;
;			Sprites
;
; ************************************************************

 include "sprite_i.s"		; Include the sprite-init file
 include "sprite_e.s"		; Include the sprite_code file



; *****************************************************************
; *****************************************************************
; ***								***
; ***	               Routines					***
; ***								***
; *****************************************************************
; *****************************************************************

 include "routine.s"		; Include the main routines
 ifeq	CONTRAST-1
  include "contrast.s"		; Include the contrast routine
 endif

; *****************************************************************
; *****************************************************************
; ***								***
; ***	               COOPERATION MODE				***
; ***								***
; *****************************************************************
; *****************************************************************

; Add COOPERATION mode
 ifeq	COOPERATION-1
  include "co_mode.s"		; Include the cooperation mode
 endif
; End of COOPERATION mode

; Start if we do not have the COOPERATION mode
 ifeq COOPERATION
Select_Player:
Sprite_Gestion_Multi:
Sprite_Fernando_Multi:
 moveq	#0,d0	; Ok !
 rts

Init_Fernando:
 moveq	#0,d0
 bra	SpriteInit

fer3c@0010:
keystat		ds.b	10

 endif
; End of conditional compilation








; *********************************************************
;
;			LINK GESTION
;
; *********************************************************

 ifeq	LINK_MODE-1
  include "link.s"		; Include the link mode
 endif

 ifeq	LINK_MODE
Sprite_Link_Gestion:
 endif









; *********************************************************
;
;			Gestion du SCROLLING
;
; *********************************************************


; Destroy : d0 - d1 / a0 - a2
SpriteAutoAppear:
 move.l	d5,a0
 add.l	LevelTestADR(a6),a0
 lea	(128*(SCREEN_Y/32))(a0),a1

 moveq	#0,d0
 moveq	#(SC_X/4),d1
\Loop:

 move.b (a0),d0
 cmpi.b #(SpriteAutoStart),d0
 bls.s	\s1
 bsr.s	NewSprite
\s1:
 addq.l #1,a0

 move.b (a1),d0
 cmpi.b #(SpriteAutoStart),d0
 bls.s	\s2
 move.l a0,a2		; Save a0 in a2
 move.l a1,a0		; a0:=a1
 bsr.s	NewSprite	; New sprite
 move.l a2,a0		; Restore a0
\s2:
 addq.l #1,a1		; Next Item
 dbra.s d1,\Loop

 move.l	LevelTestADR(a6),a0
 lea	127(a0,d5.l),a0
 addq.l	#1,a0
 moveq	#2,d1		; Donc maintenant 2 devrait suffire

\loop:

 move.b (a0),d0
 cmpi.b #(SpriteAutoStart),d0
 bls.s  \s3
 bsr.s	NewSprite
\s3:
 lea	(SC_X/4)(a0),a0

 move.b (a0),d0
 cmpi.b #(SpriteAutoStart),d0
 bls.s	\s4
 bsr.s	NewSprite
\s4:
 lea	(128-SC_X/4)(a0),a0
 dbra.s	d1,\loop

 rts

NewSprite:
 movem.l d0-d3/a0-a2,-(a7)
 sub.w	#(SpriteCorrect),d0
 add.w	d0,d0			; Calcul du No du sprite

 move.l	a0,d3
 sub.l	LevelTestADR(a6),d3	; Calcul de l'adresse Relative
 cmp.l	#(32*128),d3		; Test si on ne depasse pas le tableau
 bcc.s	\OutSide		; .w should work but ...
 clr.b	(a0)			; Clear Tab[X_Init,Y_Init]

 move.w	d3,d1
 move.w	d1,d2
 and.W	#(-(128-1)-1),d2
 lsr.w	#(7-5),d2		; Calcul de Y_Init

 andi.w  #127,d1
 lsl.w   #5,d1			; Calcul de X_Init

 bsr	 SpriteInit		; New sprite in the buffer
\OutSide:
 movem.l (a7)+,d0-d3/a0-a2
 rts

fer3c@000A:
; Le scrolling se concentre sur D0,D1
; Destroy d0,d1
UpDateScrollVar:
 clr.w  XsNew(a6)
 cmpi.w #SCROLLX,d0
 ble.s	\NS1
 cmpi.w #(128*32-SC_X*8+SCROLLX),d0
 ble.s	\NoR
 move.w #(128*32-SC_X*8+SCROLLX),d0
\NoR:
 subi.w #SCROLLX,d0
 move.w d0,XsNew(a6)
\NS1:
 clr.w  YsNew(a6)
 cmpi.w #SCROLLY,d1
 ble.s	\NS2
 cmpi.w #(32*32-SCREEN_Y+SCROLLY),d1
 bgt.s	\SupY
 subi.w #SCROLLY,d1
 move.w d1,YsNew(a6)
\NS2:
 rts
\SupY:
 move.w #(32*32-SCREEN_Y),YsNew(a6)
 rts

fer3c@0009:
Scrolling:
; In function of SCROLL_FILE and SCROLLING, we choose the right file
; to include
 ifeq	SCROLL_FILE
  ifeq SCROLLING-FAST
   include "SplitS_F.s"
  endif
  ifeq SCROLLING-SMALL
   include "SplitS.s"
  endif
 endif
 ifeq	SCROLL_FILE-1
  ifeq SCROLLING-FAST
   include "FullScrF.s"
  endif
  ifeq SCROLLING-SMALL
   include "FullScr.s"
  endif
 endif


ChangeScreen:
 ifeq	DEBUG-2
	rts
 endif
	moveq	#0,d0
	move.b	Phase(a6),d0			; N of the current screen
	move.w	Table(a6,d0.w),($600010)	; Write the adress of the current screen
	eori.b	#2,d0
	move.b	d0,Phase(a6)
	move.w	Table(a6,d0.w),d0	; Write the adress of the current screen
	lsl.l	#3,d0
	move.l	d0,Screen(a6)		; New current Screen
	rts








; *****************************************************************
;
;			STATIC DATA
;
; *****************************************************************

Intro_Text
	INTRO_MACRO

Level_Completed_Text:
	dc.w	GRAS,LEVEL1_X,10
	dc.l	Level_Str
	dc.w	NORMAL,LEVEL_X,LEVEL2_Y
	dc.l	Power_Str
	dc.w	NORMAL,LEVEL_X,LEVEL5_Y
	dc.l	Coins_Str
	dc.w	NORMAL,SLASH_X,SLASH_Y
	dc.l	Slash_Str
	dc.w	NORMAL,LEVEL_X,LEVEL3_Y
	dc.l	Secret_Str
	dc.w	NORMAL,LEVEL_X,LEVEL4_Y
	dc.l	Time_Str

Statut_Text:
	dc.w	STAT_FONT,NUMBER_X-4,STAT_Y1
	dc.l	Power_Str
	dc.w	STAT_FONT,NUMBER_X-4,STAT_Y2
	dc.l	Life_Str
	dc.w	STAT_FONT,NUMBER_X-4,STAT_Y3
	dc.l	Key_Str
	dc.w	STAT_FONT,NUMBER_X-4,STAT_Y4
	dc.l	Switch_Str

Boss_Text:
	dc.w	STAT_FONT,NUMBER_X-4,STAT_Y3
	dc.l	Boss_Str

 ifeq	LINK_MODE-1
Competition_Text:
	dc.w	GRAS,LEVEL1_X,10
	dc.l	Competition_Str
	dc.w	NORMAL,LEVEL_X,LEVEL2_Y
	dc.l	Select_Level_Str
	dc.w	NORMAL,LEVEL_X,LEVEL3_Y
	dc.l	Win_Str
	dc.w	NORMAL,LEVEL_X,LEVEL4_Y
	dc.l	Lose_Str
 endif

Fernand		INCBIN Fernand.S16	; Fernand Graph (Format 16*16)
		INCBIN Enm0.S16		; Enemy 0 Graph
		INCBIN Enm1.s16		; " 1
		INCBIN Enm2.s16		; " 2
		ifne	SPRITE_EXT
		INCBIN Enm3.s16
	 	endif

Power_Str	dc.b "POWER ",0
Secret_Str	dc.b "Secret  "
Life_Str	dc.b "LIFE  ",0
Key_Str		dc.b "KEY(S)",0
Boss_Str	dc.b "BOSS ",0
Switch_Str	dc.b "SWITCH",0
ON_Str		dc.b " ON  ",0
OFF_Str		dc.b " OFF ",0
Time_Str	dc.b "Time",0

Level_Str	dc.b "LEVEL COMPLETED",0
Thats_all_Str	dc.b "THE END",0
Game_Over_Str	dc.b "GAME OVER",0
Slash_Str	dc.b "/",0

Title:	
	dc.b "Fernando 3C v0.50",0
Menu_Str:
	dc.b "F1:Easy F2:Normal F3:Hard",0
Menu2_Str:
	dc.b "F4:Link F5:Load",0
Player_Menu_Str:
	dc.b "F1-1 F2-2 F3-3 F4-4 "
Player_Str:
	dc.b "Player",0
Speed_Str:
	dc.b "Wait ",17,18,":",0
Keyboard_Str:
	ifeq	OS-TI89
		dc.b "Key:Up&Down&Left&Right&Jump",0
	endif
	ifne	OS-TI89
		dc.b "Press Up, Down, Left, Right and Jump",0
	endif
Memory_Str:
	dc.b "MEMORY",0
Save_Str:
	dc.b "SAVE ?",0
Coins_Str:
	dc.b "COINS",0
OC_Turbo_Str:
	dc.b "O.C. "
Turbo_Str:
	dc.b "TURBO"
Vide_Str:
	dc.b 0
Copyright:
	dc.b 169,"1995-2002 TimeToTeam",0
 ifeq	LINK_MODE-1
Pass_Str:
	dc.b "PASSED ! "
Link_Str:
	dc.b "Waiting for challenger...",0
Competition_Str:
	dc.b "COMPETITION !",0
Select_Level_Str:
	dc.b "Select level :",0
Win_Str:
	dc.b "Win",0
Lose_Str:
	dc.b "Lose",0
 endif
	ifeq	LIBRARYOK-1
_library:	dc.b "fer3c",0
	endif

	end
