	include "tios.h"
	include "macros.h"
	include "flib.h"
	include "kernel.h"
	include "fer3c.h"

	xdef	_main
	xdef	_comment

_main:
Start:
	moveq	#7,d7
	lea	Start_Text(PC),a3
	jsr	fer3c::DrawText

	clr.w	tios::kb_vars+$1C
	jsr     flib::idle_loop
	
	cmp.w	#ENTER,d0
	bne.s	\NoLetsGo
	lea	Save_dat(PC),a0
	lea	fer3c::Save,a1
	movem.l	(a1),d0-d3	; get current save
	movem.l	d0-d3,-(a7)	; Save on the stack : a save is 16 bytes = 4 * Long Word
	movem.l (a0),d0-d3
	movem.l d0-d3,(a1)
	movem.l a0-a1,-(a7)

; Searching Name in folder
 pea	Folder(PC)
 move.w	tios::FOLDER_LIST_HANDLE,-(a7)
 jsr	tios::FindSymEntry
 addq.l	#6,a7
 move.l a0,d2
 beq.s	\Nothing
 move.w tios::SYM_ENTRY.hVal(a0),d0	; Get the handle of folder
 pea	File(PC)
 move.w	d0,-(a7)
 jsr	tios::FindSymEntry
 addq.l	#6,a7
 move.l a0,d2
 beq.s	\Nothing
 move.w tios::SYM_ENTRY.hVal(a0),-(a7)	; Push the handle of the prog
 jsr	kernel::exec
 addq.l	#2,a7
\Nothing:
	movem.l (a7)+,a0-a1
	movem.l (a1),d0-d3
	movem.l d0-d3,(a0)
	movem.l (a7)+,d0-d3
	movem.l d0-d3,(a1)
	bra.s	Exit
\NoLetsGo:
	cmp.w	#F1,d0
	bne.s	\NoF1
	jsr	flib::zap_screen
	WriteStr #1,#1,#4,Folder_Str
	moveq	#8*8,d3
	moveq	#1,d1
	lea	Folder(PC),a0
	bsr.s	InputStr
	bra	Start
\NoF1:
	cmp.w	#F2,d0
	bne.s	Exit
	bsr.s	InputFile
	bra	Start
Exit:
	rts

InputFile:
	jsr	flib::zap_screen
	WriteStr #1,#1,#4,File_Str
	moveq	#8*8,d3
	moveq	#1,d1
	lea	File(PC),a0

; Input : d3.w = x, d1.w = y ; a0 -> Str
; Destroy :d3, d1, d0, a0 , d4
InputStr:
 clr.w	tios::kb_vars+$1C
 moveq	#0,d4
Input:
 jsr	flib::idle_loop
 cmp.w	#ENTER,d0
 beq.s	InputDone
 cmp.w	#BACKSP,d0
 beq.s	BackSpace
 cmp.w	#SPACE,d0
 bcs.s	Input
 cmp.w	#256,d0
 bcc.s	Input
 cmp.w	#8,d4
 beq.s	Input
 move.b	d0,(a0)+
 move.w	d0,d2
 move.w	d3,d0
 bsr.s	WriteChar
 addq	#6,d3
 addq	#1,d4
 bra.s	Input
BackSpace:
 tst.w	d4
 beq.s	Input
 clr.b	-(a0)
 subq	#6,d3
 move.w	d3,d0
 moveq	#32,d2
 bsr.s	WriteChar
 subq	#1,d4
 bra.s	Input
InputDone:
 clr.b	(a0)
 rts


; Input : D0.w = x
;	  D1.w = y
;	  D2.b = Char
WriteChar:
 movem.l d0-d2/a0,-(a7)
  move.b d2,Char_Str
  WriteStr d0,d1,#4,Char_Str
 movem.l (a7)+,d0-d2/a0
 rts

Char_Str:
 dc.b "_",0


Save_dat:
	ds.b	16		; Save

Folder:
	dc.b "main"
	dc.b 0,0,0,0
	dc.b 0,0
File:
	dc.b "world"
	dc.b 0,0,0
	dc.b 0,0

Start_Text:
	dc.w	NORMAL,1,1
	dc.l	Full_Title
	dc.w	NORMAL,1,20
	dc.l	Folder_Str
	dc.w	NORMAL,8*8,20
	dc.l	Folder
	dc.w	NORMAL,1,30
	dc.l	File_Str
	dc.w	NORMAL,8*8,30
	dc.l	File
	dc.w	NORMAL,1,45
	dc.l	Choix_Str
	dc.w	NORMAL,1,55
	dc.l	Choix2_Str
	dc.w	NORMAL,1,65
	dc.l	Choix3_Str


_comment:
Full_Title:
	dc.b "External save for fer3c",0
Folder_Str:
	dc.b "Folder:",0
File_Str:
	dc.b "World :",0
Choix_Str:
	dc.b "Press ENTER to run",0
Choix2_Str:
	dc.b "F1 for folder",0
Choix3_Str:
	dc.b "F2 for file",0

	end
