;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;

;
; ************************************************************
;
;			Code of the sprites
;
; ************************************************************

SpriteGestion:
 move.l SpriteADR(a6),a5

\GestSpriteLoop:
 moveq	#0,d0		; Because many sprites need it
 moveq	#0,d1		; "
 move.w	No(a5),d0	; Get the type of the sprite
 move.w	Sprite_Code_Table(pc,d0.w),d0     
 jsr	Sprite_Code_Table(pc,d0.w)
 cmp.l	SpriteADREnd(a6),a5	; End of the Sprite-Buffer ?
 bmi.s	\GestSpriteLoop

 rts

; Lors d'un appel vers un sprite, d1.l = 0 mais seulement les 16 plus
; hauts bits de d0 sont  zro !

Sprite_Code_Table:
	dc.w Sprite_Fernando-Sprite_Code_Table		;0
	dc.w Sprite_FallDown-Sprite_Code_Table		;2
	dc.w Sprite_Laser-Sprite_Code_Table		;4
	dc.w Sprite_Explosion-Sprite_Code_Table		;6
	dc.w Sprite_Brique-Sprite_Code_Table		;8
	dc.w Sprite_Explosion2-Sprite_Code_Table	;10
	dc.w Sprite_Garbesh-Sprite_Code_Table		;12
	dc.w Sprite_Element-Sprite_Code_Table		;14
	dc.w Sprite_Fernando_Multi-Sprite_Code_Table	;16
	dc.w Sprite_Gestion_Multi-Sprite_Code_Table	;18
	dc.w Sprite_Link_Gestion-Sprite_Code_Table	;20
	dc.w Sprite_Big_Level-Sprite_Code_Table		;22

	dc.w Sprite_Blob-Sprite_Code_Table		;22
	dc.w Sprite_Bat-Sprite_Code_Table		;24
	dc.w Sprite_Fish-Sprite_Code_Table		;26
	dc.w Sprite_Fer_Hunter-Sprite_Code_Table	;28
	dc.w Sprite_Fungus-Sprite_Code_Table		;30
	dc.w Sprite_Ghost-Sprite_Code_Table		;32
	dc.w Sprite_Deca_Vert-Sprite_Code_Table		;34
	dc.w Sprite_Special_Bat-Sprite_Code_Table	;36
	dc.w Sprite_Star-Sprite_Code_Table		;38
	dc.w Sprite_Gray-Sprite_Code_Table		;40
	dc.w Sprite_Scroll_Right-Sprite_Code_Table	;42
	dc.w Sprite_Inv-Sprite_Code_Table		;44
	dc.w Sprite_Boat-Sprite_Code_Table		;46
	dc.w Sprite_Sun-Sprite_Code_Table		;48
	dc.w Sprite_Eor-Sprite_Code_Table		;50
	dc.w Sprite_Cinema-Sprite_Code_Table		;52
	dc.w Sprite_Colonne-Sprite_Code_Table		;54
	dc.w Sprite_Montagne-Sprite_Code_Table		;56
	dc.w Sprite_Tirelle-Sprite_Code_Table		;58
	dc.w Sprite_Crabe-Sprite_Code_Table		;60
	dc.w Sprite_Inv2-Sprite_Code_Table		;62
	dc.w Sprite_Gorille-Sprite_Code_Table		;64
	dc.w Sprite_Deca-Sprite_Code_Table		;66
	dc.w Sprite_Mirroir-Sprite_Code_Table		;68
	dc.w Sprite_Anim2-Sprite_Code_Table		;70
	dc.w Sprite_Conc_Scroll-Sprite_Code_Table	;72
	dc.w Sprite_Deca_Sac-Sprite_Code_Table		;74
	dc.w Sprite_Glooner-Sprite_Code_Table		;76
	dc.w Sprite_Boolder-Sprite_Code_Table		;78
	dc.w Sprite_Holo_D-Sprite_Code_Table		;80
	dc.w Sprite_FlyBoot-Sprite_Code_Table		;82
	dc.w Sprite_Scarat-Sprite_Code_Table		;84
	dc.w Sprite_Point_Dexter-Sprite_Code_Table	;86
	dc.w Sprite_Bloominator-Sprite_Code_Table	;88
	dc.w Sprite_Flamme-Sprite_Code_Table		;90
	dc.w Sprite_Nest-Sprite_Code_Table		;92
	dc.w Sprite_Add_On-Sprite_Code_Table		;94
	dc.w Sprite_Anim2_Fast-Sprite_Code_Table	;96
	dc.w Sprite_Rot-Sprite_Code_Table		;98
	dc.w Sprite_Move-Sprite_Code_Table		;100
	dc.w Sprite_All-Sprite_Code_Table		;102
	dc.w Sprite_100_Coins-Sprite_Code_Table		;104
	dc.w Sprite_Pow-Sprite_Code_Table		;136
	dc.w Sprite_Spider-Sprite_Code_Table		;138
	dc.w Sprite_Ber-Sprite_Code_Table		;140
	dc.w Sprite_Butter_Fly-Sprite_Code_Table	;142
	dc.w Sprite_Nibbles-Sprite_Code_Table		;144
	dc.w Sprite_PacMan-Sprite_Code_Table		;146
	dc.w Sprite_Boum-Sprite_Code_Table		;148
	dc.w Sprite_Plane-Sprite_Code_Table		;150


 include "spr_fer.s"

Sprite_FallDown:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	addq.w	#2,d1
	move.w	d1,Yj(a5)
	bsr	TestCollision
	bne.s	\No
	bsr	Touche
\No:	bsr	TestExitScreen
	bne.s	\Suite
	move.l	LevelTestADR(a6),a0
	move.w	Adresse(a5),d0
	move.b	#17,0(a0,d0.w)
	moveq	#FD_End,d0
	bra	DestroySprite
\Suite:	moveq	#FALLDOWN,d2
	bsr	PutSprite
	lea	FD_End(a5),a5
	rts

Sprite_Laser:
	bsr	ComportementLikeLaser
	bsr	TestCollision
	bne.s	\No
	bsr	Touche
\No:	bsr	TestExitScreen
	bne.s	\Suite
	moveq	#LaserEND,d0
	bra	DestroySprite
\Suite:	moveq	#LASER,d2
	bsr	PutSprite
	lea	LaserEND(a5),a5
	rts

Sprite_Explosion:
	move.w  EXP_Dx(a5),d3
	addq.w  #2,d3
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	sub.w   d3,d1
	moveq	#EXP_HAUT,d2
	bsr	PutSprite
	add.w	d3,d1
	add.w	d3,d1
	moveq	#EXP_BAS,d2
	bsr	PutSprite
	sub.w	d3,d1
	add.w	d3,d0
	moveq	#EXP_DROIT,D2
	bsr	PutSprite
	sub.w	d3,d0
	sub.w   d3,d0
	moveq	#EXP_GAUCHE,d2
	bsr	PutSprite
	move.w  d3,EXP_Dx(a5)
	cmpi.w  #EXP_TIME,d3
	blt.s	\Exit
	moveq	#EXP_END,d0
	bra	DestroySprite	
\Exit:	lea	EXP_END(a5),a5
	rts

Sprite_Explosion2:
	move.w  EXP_Dx(a5),d3
	addq.w  #3,d3
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	sub.w   d3,d1
	bsr	PutHor
	add.w	d3,d1
	add.w	d3,d1
	bsr	PutHor
	add.w	d3,d0
	bsr	PutVer
	sub.w	d3,d0
	sub.w   d3,d0
	bsr	PutVer
	move.w  d3,EXP_Dx(a5)
	cmpi.w  #(2*EXP_TIME),d3
	blt.s	\Exit
	moveq	#EXP_END,d0
	bra	DestroySprite	
\Exit:	lea	EXP_END(a5),a5
	rts

Sprite_Brique:
	bsr	ComportementLikeLaser
	bsr	TestExitScreen
	bne.s	\Suite
	moveq	#LaserEND,d0
	bra	DestroySprite
\Suite:
	moveq	#BRIQUE,d2
	bsr	PutSprite
	lea	LaserEND(a5),a5
	rts

Sprite_Garbesh:
	move.w	Adresse(a5),d1
	move.w	d1,d2		; Save Adresse(a5) in d2
	tst.w	Garbesh_Temp(a5)
	ble.s	\skip
	move.w	Turbo(a6),d3
	sub.w	d3,Garbesh_Temp(a5)
	bgt.s	\skip
	move.l	LevelTestADR(a6),a0
	add.w	#128,d1
	clr.b	0(a0,d1.w)
	move.l	LevelADR(a6),a0
	clr.b	0(a0,d1.w)
	move.w	#4000,YsOld(a6)	; refresh Virtual Screen
\skip:
	move.w	d2,d0		; d0 = Adresse(a5)
	andi.w	#127,d0
	lsl.w	#5,d0
	lsr.w	#2,d1
	bsr	TestExitScreen
	bne.s	\Suite_Collector
	move.w	Adresse(a5),d1
	move.l	LevelTestADR(a6),a0
	move.b	#29,0(a0,d1.w)
	add.w	#128,d1
	move.b	Garbesh_Test(a5),0(a0,d1.w)
	move.l	LevelADR(a6),a0
	move.b	Garbesh_Dessin(a5),0(a0,d1.w)
	moveq	#Garbesh_End,d0
	bra	DestroySprite
\Suite_Collector:
	lea	Garbesh_End(a5),a5
	rts	

Sprite_Element:
	cmp.b	#1,Refresh(a6)
	bne.s	\Skip
	move.l	a5,a1
	bsr	InitHandD
\Skip:
	move.b	Vitesse(a6),d3

	move.w	Ho(a5),d0	; Calcul position X,Y
	add.w	Do(a5),d0
	move.w	d0,Ho(a5)
	asr.w	d3,d0
	add.w	Xi(a5),d0

	move.w	Hi(a5),d1
	add.w	Di(a5),d1
	move.w	d1,Hi(a5)
	asr.w	d3,d1
	add.w	Yi(a5),d1

	bsr	TestCollision
	bne.s	\Ok
	move.l  SpriteADR(a6),a0	; ATTENTION : Fernando doit tre le premier
	move.w  F_Haut(a0),d2	; de la liste pile
	move.w  d2,F_St(a0)
	move.w  #10,F_Action(a0)
	cmp.w	#1,Nbr(a5)
	bne.s	\Bam
	cmp.w	Yj(a5),d7
	bge.s	\Bam
	movem.l	d0-d1,-(a7)
	moveq	#10,d0
	move.w  d6,d1
	move.w  d7,d2
	bsr	SpriteInit	; Init 1 explosion
	movem.l	(a7)+,d0-d1
	bsr	PutKey		; In fact put BossLife (same routine)
	bsr	CopyTo2ndScreen
	subq.w	#1,BossLife(a6)
	bne.s	\Ok
	move.b	#LEVEL_COMPLETED,Mort(a6)
	bra.s	\Ok
\Bam:
	bsr	Touche
\Ok:
; Affichage
	move.l	Grph(a5),a0
	bsr	PutSpriteA0

	lea	Element_End(a5),a5
	rts

InitHandD:
 move.w	Nbr(a1),d0

 move.l	Phase1ADR(a6),a0
 move.l Phase2ADR(a6),a2
 
 clr.w	d1
 clr.w	d2
 move.b 0(a0,d0.w),d1
 move.w	d1,Xi(a1)	; Formule : X = Xi + Time * Do / 2^Vitesse
 move.b	0(a2,d0.w),d2
 sub.w	d1,d2		; Changed in : Hi = Hi + D0
 move.w d2,Do(a1)	; 	X = X + Hi/2^Vitesse

 clr.w	d1
 clr.w	d2
 move.b 1(a0,d0.w),d1
 move.w	d1,Yi(a1)	; Formule : Y = Yi + Time * Di / 2^Vitesse
 move.b	1(a2,d0.w),d2
 sub.w	d1,d2
 move.w d2,Di(a1)

 clr.w	Hi(a1)
 clr.w	Ho(a1)
 rts

Sprite_Glooner:
	btst.b	#0,Blob_Vy(a5)
	bne.s	\Ok
	move.w	#1,Blob_Vy(a5)
\Ok:	move.w	#BLOB,Dessin(a5)
	move.w	Yj(a5),d1
	move.w	d1,d0
	andi.w	#15,d0
	bne.s	\Skip
	neg.w	Blob_Vy(a5)
\Skip:	add.w	Blob_Vy(a5),d1
	move.w	d1,Yj(a5)
	moveq	#63,d3
	bra.s	Blob_Entry

Sprite_Crabe:
	move.w #CRABE,Dessin(a5)
	move.w Time(a6),d0
	andi.w #127,d0
	bne.s	\Skip
	neg.w  Blob_Vx(a5)	; Change SpeedX all 128 frames
\Skip:	moveq	#54,d3		; D3 = Test in table
	bra.s	Blob_1st_Entry

Sprite_Blob:
	move.w  #BLOB,Dessin(a5)
	moveq	#33,d3		; If Blob hurts Fernando,
				; d3 will change (sub-routine touche)
				; but it can't be possible that Blob
				; must exit the sprite-buffer. I hope.
				; In multi-player, it can be possible...
				; If one Fernando is outside the screen and
				; blob hurts him AND blob must exit the sprite
				; buffer at the same frame. Damned !
				; To correct it, I must test the exit of the
				; screen before the collision with Fernando.
				; I write it only for Beta Testing.
				; Is there someone to read it ?
Blob_1st_Entry:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	addq.w	#1,d1
	bsr	GetTest
	beq.s	Blob_Entry
	move.w	d1,Yj(a5)
Blob_Entry:
	bsr	VitesseX
	bsr	TestExitScreen
	bne.s	\SkipExitScreen
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b	d3,0(a0,d0.w)	; Restaure ce qu'il faut ie d3
	moveq	#Blob_End,d0
	bra	DestroySprite
\SkipExitScreen
	bsr	TestCollision
	bne.s	\No
	cmp.w	Yj(a5),d7
	blt	DestroyBlob
	bsr	Touche
\No:	
BlobSuite:
	bsr	CalculOfD2
	bsr	PutSprite
	lea	Blob_End(a5),a5
	rts

Sprite_Bat:
	move.w  #BAT,Dessin(a5)
	moveq	#34,d3
 	bra.s	Blob_Entry

Sprite_Special_Bat:
	move.w  #BAT,Dessin(a5)
	moveq	#40,d3
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	Blob_Vy(a5),d4
	add.w	d4,d1
	neg.w	d4
	bsr	GetTest
	beq.s	\Saut
	move.w	d1,Yj(a5)
	neg.w	d4
\Saut:
	move.w  d4,Blob_Vy(a5)
 	bra.s	Blob_Entry


Sprite_FlyBoot:
	bsr	VitesseX
	moveq	#8,d2
	add.w	d2,d0
	add.w	d2,d1

	bsr	TestCollision
	bne.s	\No
	cmp.w	Yj(a5),d7
	blt	DestroyBlob
	bsr	Touche
\No:	
	bsr	TestExitScreen
	bne.s	\Suite
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b	#67,0(a0,d0.w)
	moveq	#Blob_End,d0
	bra	DestroySprite

\Suite:
	move.w	#BAT,Dessin(a5)
	bsr	CalculOfD2
	bsr	PutSprite

	move.w	Time(a6),-(a7)
	moveq	#3,d5
\Loop:
	move.l	a5,-(a7)
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	bsr	IN_STAR
	move.l	(a7)+,a5
	add.w	#(512/4),Time(a6) ; 512 is the periode of the star
	dbf.s	d5,\Loop
	move.w	(a7)+,Time(a6)

	lea	Blob_End(a5),a5
	rts

Sprite_Fish:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	move.w	Turbo(a6),d2
	add.w   Fish_Vy(a5),d1
	move.w  d1,Yj(a5)
	sub.w   d2,Fish_Loop(a5)
	bgt.s	\Ok
	move.w  #(32*3),Fish_Loop(a5)
	neg.w	Fish_Vy(a5)
\Ok:
	bsr	TestCollision
	bne.s	\No
	moveq	#Fish_End,d3
	cmp.w	Yj(a5),d7
	blt	Destroy
	bsr	Touche
\No:	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  #35,0(a0,d0.w)
	moveq.l #Fish_End,d0
	bra	DestroySprite
\Suite1:
;	moveq	#0,d2
	move.w  Fish_A(a5),d2
	addq.w  #1,d2
	andi.w  #31,d2
	move.w  d2,Fish_A(a5)
	lsr.w   #4,d2
	addi.w  #FISH,d2
	bsr	PutSprite
	lea	Fish_End(a5),a5
	rts

FH_xInf:
	bclr.b	#Left_Key,d4	; Left
	bra.s	FH_C1
FH_xSup:
	bclr.b	#Right_Key,d4	; Right
	bra.s	FH_C1
FH_yInf:
	bclr.b	#Jump_Key,d4	; hand
	bclr.b	#Up_Key,d4	; up
	bra.s	FH_C2

Sprite_Fer_Hunter:
	moveq	#-1,d4
	cmp.w	Xj(a5),d6
	blt.s	FH_xInf
	bgt.s	FH_xSup
FH_C1:
	cmp.w	Yj(a5),d7
	blt.s	FH_yInf
FH_C2:
	move.w	keystat(PC),-(a7)
	move.b	d4,(keystat-fer3c@0001)(a6)

	move.l	XsNew(a6),-(a7)	; Xs & Ys
	move.l	Vi(a6),-(a7)	; Stockage de Vi & Bj
	move.w	v(a6),-(a7)
	move.b	Mort(a6),-(a7)
	movem.l d6-d7/a5,-(a7)
	move.w	FH_Bj(a5),Bj(a6)
	move.w	FH_V(a5),v(a6)
	move.b	#OK,Mort(a6)
	bsr	Sprite_Fernando
	move.b	Mort(a6),d4
	movem.l	(a7)+,d6-d7/a5
	move.w	Bj(a6),FH_Bj(a5)
	move.w	v(a6),FH_V(a5)
	move.b	(a7)+,Mort(a6)
	move.w	(a7)+,v(a6)
	move.l	(a7)+,Vi(a6)	; Vi & Bj
	move.l	(a7)+,XsNew(a6)	; Xs & Ys
	move.w	(a7)+,(keystat-fer3c@0001)(a6)

	moveq	#FH_End,d3
	tst.b	d4
	beq	Destroy

	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	bsr	TestCollision
	bne.s	\No
	cmp.w	Yj(a5),d7
	blt.s	\FH_Destroy
	bsr	Touche
	bra.s	\No
\FH_Destroy:
	tst.w	FH_V(a5)
	bne.s	\No1
	move.w	#80,FH_V(a5)
	sub.w	#20,FH_Bj(a5)
	ble	Destroy
\No1:
	move.l  SpriteADR(a6),a0	; ATTENTION : Fernando doit tre le premier
	move.w  F_Haut(a0),d2		; de la liste pile
	move.w  d2,F_St(a0)
	move.w  #10,F_Action(a0)
\No:	
      	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  FH_Adresse(a5),d0
	move.b  #36,0(a0,d0.w)
	moveq	#FH_End,d0
	bra	DestroySprite
\Suite1:
	lea	FH_End(a5),a5
	rts

Sprite_Fungus:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	add.w	Turbo(a6),d1
	bsr	GetTest
	beq.s	\skip
	move.w	d1,Yj(a5)
\skip:
	move.w	Yj(a5),d1
	bsr	TestCollision
	bne.s	\No
	cmp.w	Yj(a5),d7
	blt.s	Fungus_Destroy
	bsr	Touche
\No:	
	bsr	TestExitScreen
	bne.s	Fungus_SKIP
	move.l	LevelTestADR(a6),a0
	move.w	Adresse(a5),d0
	move.b	#37,0(a0,d0.w)
	moveq	#Fungus_End,d0
	bra	DestroySprite
Fungus_Destroy:
	move.l	SpriteADR(a6),a0 ; ATTENTION : Fernando doit tre le premier
	move.w  F_Haut(a0),d3	; de la liste pile
	move.w  d3,F_St(a0)
	move.w  #10,F_Action(a0)
	moveq	#Fungus_End,d3
	subq.w	#1,Fungus_Vi(a5)
	bne.s	Fungus_SKIP
	bra	Destroy
Fungus_SKIP:
	move.w	#FUNGUS,Dessin(a5)
	bsr	CalculOfD2
	bsr	PutSprite
	lea	Fungus_End(a5),a5
	rts

Sprite_Ghost:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	addq.w	#1,d0
	addq.w	#1,d1
	cmp.w	d0,d6
	bgt.s	\C1
	subq.w	#2,d0
\C1:	cmp.w	d1,d7
	bgt.s	\C2
	subq.w	#2,d1
\C2:	move.w	d0,Xj(a5)
	move.w	d1,Yj(a5)
	bsr	TestCollision
	bne.s	\No
	tst.w	Bj
	beq.s	\No
	move.w	Blob_A(a5),d2
	bne.s	\No
	subq.w	#1,Bj(a6)
	bsr	PutPower
	bsr	CopyTo2ndScreen
\No:	
      	bsr	TestExitScreen
	bne.s	Ghost_SKIP
Ghost_Destroy:
	move.l   LevelTestADR(a6),a0
	move.w   Adresse(a5),d0
	move.b   #38,0(a0,d0.w)
	moveq.l  #Ghost_End,d0
	bra	DestroySprite
Ghost_SKIP:
	move.w	#GHOST,Dessin(a5)
	bsr	CalculOfD2
	bsr	PutSprite
	lea	Ghost_End(a5),a5
	rts

Sprite_Deca_Vert:
 move.w Time(a6),d0
 andi.w #7,d0
 bne.s	\Skip
 move.l Eor_Graph(a5),a0
 moveq.l #30,d3
 lea	(4*31)(a0),a0	; On pointe  la fin
 move.l	(a0),d2		; On lit et conserve le dernier
 lea	4(a0),a1
\Deca_loop:
 move.l -(a0),-(a1)	; On recopie
 dbra.s	d3,\Deca_loop
 move.l	d2,(a0)
 move.w #4000,YsOld(a6)
\Skip:
 addq.l	#Eor_End,a5
 rts

Sprite_Star:
	move.w	Xj(a5),d0	; X
	move.w	Yj(a5),d1	; Y
	moveq	#41,d3
        bsr	TestExitScreen
	beq	DestroyStar	; Destroy and restore d3
IN_STAR:
	move.w	Time(a6),d2
	lsr.w	#3,d2
	move.w	d2,d3
	move.w	d3,d4
	lsr.w	#3,d3
	andi.w	#6,d3
	andi.w	#15,d4
	move.w	Star_Table(PC,d3.w),d3
	jsr	Star_Table(PC,d3.w)	; Correct (x,y)
	move.w	d2,d3
	bsr	TestCollision
	bne.s	\DSkip
	bsr	Touche
\DSkip:
;	moveq	#0,d2
	move.w	d3,d2
	andi.w	#1,d2
	add.w   #ETOILE,d2
	bsr	PutSprite
	lea	Star_End(a5),a5
	rts
Star_Table:
	dc.w Star1-Star_Table
	dc.w Star2-Star_Table
	dc.w Star3-Star_Table
	dc.w Star4-Star_Table
Star1:	add.w	d4,d0
	rts
Star2:	add.w	d4,d1
	add.w	#16,d0
	rts
Star3:	add.w	#16,d0
	add.w	#16,d1
	sub.w	d4,d0
	rts
Star4:	add.w	#16,d1
	sub.w	d4,d1
	rts

Sprite_Scroll_Right:
	move.w	Xj(a5),d0
	ifeq	MOVE_SCR-1
	move.w	d0,d2
	add.w	#(SCROLLX),d2
	sub.w	d6,d2
	move.w	d2,Look_X(a6) ; No Move : del a bug
	endif
	cmpi.w	#(128*32-SC_X*8),d0
	bls.s	\SKIP
	moveq	#43,d3
	bra	DestroyStar
\SKIP:
	add.w	Turbo(a6),d0
	move.w	d0,XsNew(a6)
	move.w	d0,Xj(a5)
	cmp.w   d0,d6
	bhi.s	\Ok
	clr.b	Mort(a6)	; You die !
\Ok:
	lea	Scroll_R_End(a5),a5
	rts


Sprite_Inv:
 ifeq	SPECIAL_EFFECT-1
	move.w Time(a6),d4
	lsr.w  #1,d4
	moveq	#0,d3
	move.l	Screen(a6),a0
	moveq	#(SCREEN_Y-1),d0
	move.w	Yj(a5),d1
	sub.w	Ys(a6),d1
	blt.s	Deca_Loop1
	move.w	d1,d0
	cmpi.w	#SCREEN_Y,d0
	bcc.s	NoPrint

	add.w	d1,d1
	move.l  d1,d2
	lsl.w   #4,d2
	sub.w   d1,d2
 
	adda.l  d2,a0

	neg.w	d0
	addi.w	#(SCREEN_Y-1),d0
Deca_Loop1:
	andi.w	#15,d4
	move.b	Deca_Table(PC,d4.w),d3
	moveq.l	#(SC_X/2-1),d1
Deca_Loop2:
	move.l	(a0),d2
	lsr.l	d3,d2
	move.w	d2,(a0)+
	dbf.s	d1,Deca_Loop2
	NEXT_ROW	a0
	addq.w	#1,d4
	dbf.s	d0,Deca_Loop1
NoPrint:
	lea	Inv_End(a5),a5
	rts
Deca_Table:
	dc.b	13,13,12,11
	dc.b	10,10,11,12
	dc.b	13,13,14,15
	dc.b	16,16,15,14
 endif

Sprite_Rot:
 ifeq	SPECIAL_EFFECT-1
;	move.w	Xs(a6),d3
;	and.w	#15,d3
;	move.l	Screen(a6),a0
;	moveq.l	#(SCREEN_Y-1),d1
;\_Loop1:
;	moveq.l	#(SC_X/2-1),d0
;\_Loop2:
;	move.w	(a0),d2
;	rol.w	d3,d2
;	move.w	d2,(a0)+
;	dbf.s	d0,\_Loop2
;	NEXT_ROW	a0
;	dbf.s	d1,\_Loop1
	moveq	#SCREEN_X,d2
	move.w	Xj(a5),d0
	add.w	Turbo(a6),d0	; Turbo < SCREEN_X +1! ! ! !
	cmp.w	d2,d0
	blt.s	\Ok
	sub.w	d2,d0
\Ok:
	move.w	d0,Xj(a5)
	bclr.b	#0,d0
	move.l	Screen(a6),a0
	add.l	d0,a0
	moveq	#(SCREEN_Y-1),d1
\Loop:
	not.w	(a0)
	add.l	d2,a0
	dbf.s	d1,\Loop
	lea	Inv_End(a5),a5
	rts
 endif


Sprite_Boat:
 ifeq	SPECIAL_EFFECT-1
 move.w Time(a6),d1
 move.w YsNew(a6),d0
 lsr.w  #2,d1
 andi.w #31,d1
 cmpi.w #16,d1
 bls.s	\Nothing
 addi.w #32,d0
 neg.w  d1
\Nothing:
 add.w  d1,d0
 cmpi.w #(32*32-SCREEN_Y),d0
 bhi.s	\No
 move.w d0,YsNew(a6)
\No:
 lea	Boat_End(a5),a5
 rts
 endif

Sprite_Sun:
 ifeq	SPECIAL_EFFECT-1
 move.w Time(a6),d1
 move.w d1,d2
 and.w 	Turbo(a6),d2
 bne.s	\Skip_SUN

 lsr.w  #4,d1
 andi.w #30,d1
 lea     Fernand(PC),a0
 adda.l  #(SUN*32),a0
 adda.l  d1,a0
 not.w	(a0)

 bsr	LikeSun
 moveq	#SUN,d2
 bsr	PutSprite
 
 not.w	(a0)

\Skip_SUN:
 addq.l	#Sun_End,a5
 rts
 endif

Sprite_Eor:
 moveq	#31,d2
 move.w Time(a6),d3
 and.w	d2,d3
 bne.s	\Skip2
 move.l Eor_Graph(a5),a0
\EOR_loop:
 not.l	(a0)+
 dbf.s	d2,\EOR_loop
 move.w #4000,YsOld(a6)
\Skip2:
 addq.l	#Eor_End,a5
 rts

Sprite_Cinema:
 ifeq	SPECIAL_EFFECT-1
 move.l Screen(a6),a0
 moveq	#-1,d4
 moveq	#1,d0
\l0:
 moveq	#15,d1
\l1:
 moveq	#(SC_X/2-1),d2
\l2:
 move.w d4,(a0)+
 dbf.s	d2,\l2
 NEXT_ROW	a0
 dbf.s	d1,\l1
 lea	((SCREEN_Y-32)*SCREEN_X)(a0),a0
 dbf.s	d0,\l0
 addq.l	#Cinema_End,a5
 rts
 endif

Sprite_Colonne:
 ifeq	SPECIAL_EFFECT-1
	move.w	Xj(a5),d0
	move.w	Ys(a6),d1
	move.w	d1,d3
	bsr	TestExitScreen
	bne.s	\SKIP
	moveq	#51,d3
	bra	DestroyStar
\SKIP:
	move.w  Xs(a6),d0
	lsr.l	#2,d0
	add.w	Yj(a5),d0
	neg.w   d0
	addi.w	#32,d0		; ?????????
	andi.w  #31,d0
	cmpi.w  #(SC_X-1),d0
	bhi.s	\NoPut
	move.l  Screen(a6),a0
	add.l   d0,a0
	moveq	#(SCREEN_Y-1),d0
	move.b	#$FE,d1
	andi.w	#7,d3
	rol.b	d3,d1
\loop:
	move.b  d1,(a0)
	rol.b   #1,d1
	lea	SCREEN_X(a0),a0
	dbf.s	d0,\loop
\NoPut:
	lea	Colonne_End(a5),a5
	rts
 endif

Sprite_Montagne:
 ifeq	SPECIAL_EFFECT-1
 move.w Time(a6),d0
 andi.w #1,d0
 beq.s	\Skip
 bsr	LikeSun
 moveq	#MONTAGNE,d2		; Montagne dans la lune
 bsr    PutSprite
\Skip:
 addq.l	#Sun_End,a5
 rts
 endif

Sprite_Tirelle:
	move.w	Time(a6),d0
	move.w	d0,d1
	lsr.w	#3,d1
	andi.w	#15,d1
	add.w	Xj(a5),d1	; Calcul of X
	move.w	Yj(a5),d2
	andi.w	#(128+7),d0	; Fire ? (<- Time)
	bne.s	\NoFire
	moveq	#0,d4
	moveq	#-2,d5
	moveq	#4,d0
	bsr     SpriteInit	; Init Laser
\NoFire:
	move.w	d1,d0
	move.w	d2,d1
	bsr	TestExitScreen
	bne.s	\SKIP
	moveq	#53,d3
	bra	DestroyStar
\SKIP:
	moveq	#TIRELLE,d2
	bsr	PutSprite
	lea	Star_End(a5),a5
	rts


Sprite_Inv2:
 ifeq	SPECIAL_EFFECT-1
;	move.w Time(a6),d1
;	lsr.w  #2,d1
;	andi.w #15,d1
;	neg.w  d1
;	addi.w #16,D1

;	add.w	d1,d1
;	move.l  d1,d2
;	lsl.w   #4,d2
;	sub.w   d1,d2
;	move.l  Screen(a6),a1
;	adda.l  d2,a1
;	moveq.l #(SCREEN_Y/16-1),d1
;\PutHorLOOP:
;	moveq.l #(SC_X/4-1),d0
;\putLoop:
;	move.l  (a1),d2
;	lsr.l   #2,d2
;	move.l  d2,(a1)+
;	dbra.s	d0,\putLoop
;	lea     (SCREEN_X-SC_X+SCREEN_X*14)(a1),a1
;	dbra.s	d1,\PutHorLOOP
	move.w	Time(a6),d1
	lsr.w	#3,d1
	move.w	#%1000110010000101,d2	; Data for inv2
	move.l	Screen(a6),a0
	lea	SCREEN_X(a0),a1
	moveq	#SCREEN_X,d3
	moveq	#SCREEN_Y-2,d0
\Loop:
	subq.w	#1,d1
	andi.w	#15,d1
	btst.w	d1,d2
	beq.s	\No		; No Zoom of this line
	moveq	#(SC_X/2-1),d4	; Plus on a de registres
\ll:				; plus on en consomme !
	move.w	(a0)+,(a1)+
	dbf.s	d4,\ll
	NEXT_ROW	a0
	NEXT_ROW	a1
	bra.s	\Next
\No:
	add.l	d3,a0	; Next line
	add.l	d3,a1	; Next line
\Next:
	dbf	d0,\Loop
	lea     Inv_End(a5),a5
	rts
 endif

Sprite_Gorille:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	move.w  Time(a6),d2
	andi.w	#3,d2
	bne.s	\Ok
	add.w	Gorille_Vx(a5),d0
	move.w	d0,Xj(a5)
	move.w	Turbo(a6),d2
	sub.w   d2,Gorille_Loop(a5)
	bne.s	\Ok
	move.w  #(32*2),Gorille_Loop(a5)
	neg.w	Gorille_Vx(a5)
	eor.w	#1,Gorille_Sens(a5)
\Ok:
	subq.w	#1,d1
	bsr	TestCollision
	bne.s	\No
\Yeah:
	move.l	SpriteADR(a6),a0
	tst.w	F_Action(a0)	; Does Fernando dance ?
	bne.s	\BadaBoum
	tst.b	F_BWait(a0)
	beq.s	\No
\BadaBoum:
	move.w	#8,F_Action(a0)	; Propulseur
	clr.w	F_My(a0)
	move.W  #5,F_Mx(a0)
	cmp.w	Xj(a5),d6
	bhi.s	\No
	neg.w	F_Mx(a0)
\No:	
	move.w	Yj(a5),d1
	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  #56,0(a0,d0.w)
	moveq	#Gorille_End,d0
	bra	DestroySprite
\Suite1:
;	moveq	#0,d2
	move.w  Gorille_A(a5),d2
	addq.w  #1,d2
	andi.w  #63,d2
	move.w  d2,Gorille_A(a5)
	andi.w  #48,d2
	lsr.w   #3,d2
	add.w   #GORILLE,d2
	add.w   Gorille_Sens(a5),d2
	bsr	PutSprite
	lea	Gorille_End(a5),a5
	rts

Sprite_Deca:
	move.w Time(a6),d0
	andi.w #7,d0
	bne.s	\SkipDeca
	move.l Eor_Graph(a5),a0
	moveq	#31,d3
\Deca_loop:
	move.l	(a0),d4
	rol.l	#1,d4
	move.l	d4,(a0)+
	dbra.s	d3,\Deca_loop
	move.w	#4000,YsOld(a6)
\SkipDeca:
	addq.l	#Eor_End,a5
	rts

Sprite_Mirroir:
 ifeq	SPECIAL_EFFECT-1
	move.l	(a7),d0		; Bidouille infame ! ! ! ! ! ! ! 
	move.l	d0,-(a7)	; On modifie l'adresse de retour
	move.l	d0,-(a7)	; Translation de l'adresse + 8
	move.l	a5,8(a7)	; On y ecrit a5
	lea	Code_Mirroir(PC),a0
	move.l	a0,4(a7)	; Et sa propre routine !
	lea	Star_End(a5),a5	; Next sprite.
	rts
Code_Mirroir:
	move.l	(a7)+,a5	; Read a5
	move.w Time(a6),d1
	lsr.w	#3,d1
	move.w Yj(a5),d0
	andi.w #63,d1
	cmpi.w #32,d1
	bls.s	\Nothing
	addi.w #64,d0
	neg.w  d1
\Nothing:
	add.w  d1,d0
	sub.w  Ys(a6),d0
	move.w d0,d1
	cmpi.w #128,d0
	bcc.s	\NoPrint
	move.l	Screen(a6),a0
	
	add.w	d1,d1
	move.l	d1,d2
	lsl.w	#4,d2
	sub.w	d1,d2
	
	adda.l  d2,a0
	lea	-SCREEN_X(a0),a1
	
	move.l a1,a2
	moveq	#(SC_X/4-1),d2
	moveq	#-1,d3
\l1:
	move.l	d3,(a2)+
	dbf.s	d2,\l1
	neg.w	d0
	addi.w	#(127),d0	; It doesn't work if ScreenY>128 Rows !!!
	moveq	#(SCREEN_X+SC_X),d3
\Loop1:
	moveq	#(SC_X/4-1),d2
\Loop2:
	move.l	(a1)+,(a0)+
	dbf.s	d2,\Loop2
	NEXT_ROW	a0
	sub.l  d3,a1
	moveq	#(SCREEN_X+2*SC_X),d4
	sub.w  d3,d4
	move.w d4,d3
	dbf.s	d0,\Loop1
\NoPrint:   
	rts
 endif

Sprite_Anim2_Fast:
	move.w	Time(a6),d3
	andi.w	#15,d3
	beq.s	Sprite_Gray
	addq.l	#Eor_End,a5
	rts

Sprite_Anim2:
	move.w	Time(a6),d3
	andi.w	#31,d3
	bne.s	SkipAnim2
Sprite_Gray:
	move.w	#4000,YsOld(a6)
	move.l	Eor_Graph(a5),a0
	lea	128(a0),a1
	moveq	#15,d3
\Anim2_loop:
	move.l	(a0),d4
	move.l	(a1),(a0)+
	move.l	d4,(a1)+
	move.l	(a0),d4
	move.l	(a1),(a0)+
	move.l	d4,(a1)+
	dbra.s	d3,\Anim2_loop
SkipAnim2:
	addq.l	#Eor_End,a5
	rts

Sprite_Conc_Scroll:
 move.w	Xj(a5),d0
 move.w	Yj(a5),d1
 bsr	TestExitScreen
 bne.s	\NoExit
 move.l  LevelTestADR(a6),a0
 move.w  Adresse(a5),d0
 move.b  #61,0(a0,d0.w)
 moveq.l #CAS_End,d0
 bra	DestroySprite
\NoExit:
 move.w	XsNew(a6),d2
 add.w	#SCROLLX,d2
 move.w	YsNew(a6),d3
 add.w	#SCROLLY,d3
 add.w	d2,d0		; Fernand a un poids de 3
 add.w	d3,d1		; Le sprite 1
 add.w	d2,d0
 add.w	d3,d1
 add.w	d2,d0
 add.w	d3,d1		; Xs=UpDateX((3*Ferx+Srx)/4)
 lsr.w	#2,d0		; Ys=UpDateY((3*Ferx+Sry)/4)
 lsr.w	#2,d1
 bsr	UpDateScrollVar
 lea	CAS_End(a5),a5
 rts

Sprite_Deca_Sac:
 move.w Time(a6),d3
 move.w	d3,d1
 andi.w #15,d3
 bne.s	SkipDecaSac
 move.l Eor_Graph(a5),a0
 moveq	#30,d3
 lsr.w	#4,d1
 moveq	#0,d2
Deca2_loop:
 andi.w	#30,d1
 move.w Deca_Sac_Table(PC,d1.w),(Deca_Code-fer3c@0001)(a6)
 addq.w	#2,d1
 move.l	(a0),d4
Deca_Code:
 rol.l	#1,d4
 move.l	d4,(a0)+
 dbra.s	d3,Deca2_loop
 move.w #4000,YsOld(a6)
SkipDecaSac:
 addq.l	#Eor_End,a5
 rts
Deca_Sac_Table:
	ror.l	#1,d4
	ror.l	#1,d4
	nop
	nop
	rol.l	#1,d4
	rol.l	#1,d4
	nop
	nop
	rol.l	#1,d4
	rol.l	#1,d4
	nop
	nop
	ror.l	#1,d4
	ror.l	#1,d4
	nop
	nop

Sprite_Boolder:
 move.w	Xj(a5),d1
 move.w Yj(a5),d2
 move.w	Turbo(a6),d0
 move.w Boolder_C(a5),d3
 sub.w	d0,Boolder_Time(a5)
 bne.s	\Skip
 move.w	#20,Boolder_Time(a5)
 addq.w	#4,d3
 andi.w	#28,d3
 move.w	d3,Boolder_C(a5)
 move.w Boolder_Table(PC,d3.w),d4
 move.w (Boolder_Table+2)(PC,d3.w),d5
 moveq	#4,d0
 bsr	SpriteInit
\Skip:
 move.w	d1,d0
 move.w	d2,d1
 bsr	TestExitScreen
 bne.s	\Suite1
 move.l  LevelTestADR(a6),a0
 move.w  Adresse(a5),d0
 move.b  #64,0(a0,d0.w)
 moveq.l #Boolder_End,d0
 bra	DestroySprite
\Suite1:
 moveq	#SUN,d2
 bsr	PutSprite
 add.w	Boolder_Table(PC,d3.w),d0
 add.w	(Boolder_Table+2)(PC,d3.w),d1
 bsr	PutSprite
 lea	Boolder_End(a5),a5
 rts
Boolder_Table:
	dc.w	2,0,1,1,0,2,-1,1,-2,0,-1,-1,0,-2,1,-1


Sprite_Holo_D:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	bsr	TestCollision
	bne.s	\No
	moveq.l	#Holo_D_End,d3
	cmp.w	Yj(a5),d7
	blt	Destroy
	bsr	Touche
\No:	
	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  #65,0(a0,d0.w)
	move.w	Holo_D_Sens(a5),d3
	bgt.s	\Ok0
	move.b  #66,0(a0,d0.w)
\Ok0:
	moveq	#Holo_D_End,d0
	bra	DestroySprite
\Suite1:
	moveq	#BLASTOID,d2
	move.w	Holo_D_Sens(a5),d3
	bgt.s	\Ok
	addq.w	#1,d2
\Ok:	bsr	PutSprite
	add.w	d3,d0
	bsr	TestCollision
	bne.s	\Skip
	bsr	Touche
\Skip:	moveq	#0,d2
	bsr	PutSprite
	lea	Holo_D_End(a5),a5
	rts

Sprite_Scarat:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	Turbo(a6),d2
	move.w	Time(a6),d3
	andi.w	#7,d3
	bne.s	\Next0
	sub.w	d2,Scarat_Loop(a5)
	bne.s	\Ok
	move.w	#60,Scarat_Loop(a5)
	move.w	#SCARAT,Dessin(a5)
	neg.w	Scarat_Sens(a5)
	bgt.s	\Ok
	addq.w	#1,Dessin(a5)
\Ok:	
	add.w	Scarat_Sens(a5),d0
	move.w	d0,Xj(a5)
\Next0:	bsr	TestCollision
	bne.s	\No
	moveq.l	#Scarat_End,d3
	cmp.w	Yj(a5),d7
	blt	Destroy
	bsr	Touche
\No:	
	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  #68,0(a0,d0.w)
	moveq.l #Scarat_End,d0
	bra	DestroySprite
\Suite1:
;	moveq	#0,d2
	move.w	Dessin(a5),d2
	bsr	PutSprite
	subq.w	#1,Scarat_Loop_2(a5)
	bne.s	\Next
	neg.w	Scarat_Sens_2(a5)
	move.w	#24,Scarat_Loop_2(a5)
\Next:
	move.w	Scarat_Xj_2(a5),d3
	add.w	Scarat_Sens_2(a5),d3
	move.w	d3,Scarat_Xj_2(a5)
	add.w	d3,d0
	subq.w	#7,d1
	bsr	TestCollision
	bne.s	\Next2
	bsr	Touche
\Next2:
	moveq	#ETOILE2,d2
	bsr	PutSprite
	lea	Scarat_End(a5),a5
	rts

Sprite_Point_Dexter:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	Turbo(a6),d2
	moveq	#69,d4
	move.w	Time(a6),d3
	andi.w	#7,d3
	bne.s	Point_Dexter_Entry
	sub.w	d2,Point_Loop(a5)
	bne.s	\Skip
	move.w	#80,Point_Loop(a5)
	move.w	#POINT_DEXTER,Dessin(a5)
	neg.w	Point_Sens(a5)
	bgt.s	\Skip
	addq.w	#1,Dessin(a5)
\Skip:
	add.w	Point_Sens(a5),d0
	move.w	d0,Xj(a5)
Point_Dexter_Entry:
	bsr	TestCollision
	bne.s	\No
	moveq.l	#Point_End,d3
	cmp.w	#1,Point_Sens(a5)
	beq.s	\No0
	cmp.w	Yj(a5),d7
	blt	Destroy
\No0:	bsr	Touche
\No:	
	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  d4,0(a0,d0.w)
	moveq	#Point_End,d0
	bra	DestroySprite
\Suite1:
;	moveq	#0,d2
	move.w	Dessin(a5),d2
	bsr	PutSprite
	lea	Point_End(a5),a5
	rts

Sprite_Bloominator:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	Turbo(a6),d2
	moveq	#70,d4
	move.w	Time(a6),d3
	andi.w	#15,d3
	bne.s	Point_Dexter_Entry
	sub.w	d2,Point_Loop(a5)
	bne.s	\Skip
	move.w	#16,Point_Loop(a5)
	move.w	#BLOOMINATOR,Dessin(a5)
	neg.w	Point_Sens(a5)
	bgt.s	\Skip
	addq.w	#1,Dessin(a5)
\Skip:
	add.w	Point_Sens(a5),d1
	move.w	d1,Yj(a5)
	bra	Point_Dexter_Entry

Sprite_Flamme:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	Flamme_Loop(a5),d2
	move.w	Time(a6),d3
	cmp.w	#22,d2
	bls.s	\Sk1
	cmp.w	#42,d2
	bhi.s	\Sk1
	andi.w	#3,d3
	bne.s	\Sk2
\Sk1:
	sub.w	Turbo(a6),d2
	bne.s	\Next
	neg.w	Flamme_Sens(a5)
	moveq	#64,d2
\Next:
	add.w	Flamme_Sens(a5),d0
	move.w	d0,Xj(a5)
	move.w	d2,Flamme_Loop(a5)
\Sk2:
	bsr	TestCollision
	bne.s	\No
	bsr	Touche
\No:	
	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  #71,0(a0,d0.w)
	moveq.l #Flamme_End,d0
	bra	DestroySprite
\Suite1:
	moveq	#FLAMME,d2
	bsr	PutSprite	
	lea	Flamme_End(a5),a5
	rts

Sprite_Nest:
; Init a new sprite ?
	move.w	Nest_Count(a5),d3
	add.w	Turbo(a6),d3
	cmp.w	Nest_T(a5),d3
	bls.s	\Exit
	clr.w	d3	; new value of  Nest_T
	subq.w	#1,Nest_Kill(a5)
	beq.s	\Kill	; Kill the sprite ?
	moveq	#0,d0
	move.b	Nest_Gfx(a5),d0
	cmp.b	#(SpriteAutoStart),d0
	bls.s	\No	; No init
	sub.w	#(SpriteCorrect),d0
	add.w	d0,d0	; Calculate the value of the sprite_init_code
	move.w	Xj(a5),d1
	move.w	Yj(a5),d2
	clr.w	d3
	bsr	SpriteInit
\No:
\Exit:
	move.w	d3,Nest_Count(a5)

	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	bsr	TestExitScreen
	bne.s	\Suite
\Kill:
	move.l	LevelTestADR(a6),a0
	move.w	Adresse(a5),d0
	move.w	Nest(a5),d1
	move.b	d1,0(a0,d0.w)
	move.l	LevelADR(a6),a0
	move.b	Nest_Gfx(a5),d1
	move.b	d1,0(a0,d0.w)
	moveq	#Nest_End,d0
	bra	DestroySprite
\Suite:
	lea	Nest_End(a5),a5
	rts

Sprite_Add_On:
	move.l	ExecAddOnADR(a6),a0
	beq.s	\Error
	jmp	(a0)
\Error:
	rts	; Je sais pas si ce cas est possible, m'enfin...


Sprite_Move:
	move.l	LevelADR(a6),a0
	move.l	LevelTestADR(a6),a1
	
	move.w	Move_Adr(a5),d0
	move.w	Turbo(a6),d1
	sub.w	d1,Move_T(a5)
	bgt.s	\Exit

	move.w	#32,Move_T(a5)
	move.w	d0,d2		; Save Move_Adr
	add.w	Move_V(a5),d0
	cmp.w	#(32*128),d0
	bcc.s	\Change_Dir	; Outside the tab
	
	move.b	0(a1,d0.w),d1
	bne.s	\Change_Dir	; On a real test, skip
	
	move.w	d0,Move_Adr(a5)
	clr.b	0(a0,d2.w)	; Clear the tab gfx
	clr.b	0(a1,d2.w)	; Clear the tab test
	move.b	Move_Gfx(a5),0(a0,d0.w)
	move.b	Move_Tst(a5),0(a1,d0.w)
	move.w	#4000,YsOld(a6)
	bra.s	\Exit
\Change_Dir:
	move.w	Move_A(a5),d2
	addq.w	#2,d2
	andi.w	#%0110,d2
	move.w	d2,Move_A(a5)
	add.w	Move_Tab(a5),d2
	move.w	M_Tab(PC,d2.w),Move_V(a5)
\Exit:
	move.w  d0,d1		; D0 has the adress
	and.w	#(-(128-1)-1),d1
	lsr.w	#(7-5),d1	; Y position
	andi.w  #127,d0
	lsl.w   #5,d0		; X position
	bsr	TestExitScreen
	bne.s	\Skip
	move.w	Move_Adr(a5),d0
	clr.b	0(a0,d0.w)	; Clear the tab gfx
	clr.b	0(a1,d0.w)	; Clear the tab test
	move.w	Move_CAdr(a5),d0
	move.b	Move_Gfx(a5),0(a0,d0.w)
	move.b	Move_CTst(a5),0(a1,d0.w)
	moveq	#Move_End,d0
	bra	DestroySprite
\Skip:
	lea	Move_End(a5),a5
	rts
M_Tab:
	dc.w	1,128,-1,-128
	dc.w	1,-1,1,-1
	dc.w	128,-128,128,-128
	dc.w	-1,-128,1,128
	dc.w	129,-127,-129,127


Sprite_All:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	bsr	TestExitScreen
	bne.s	InitAllSprite
	moveq	#87,d3
	bra	DestroyStar
InitAllSprite:			; Init all sprites in the screen
	moveq	#0,d0
	moveq	#0,d1
	move.w	Xs(a6),d0
	move.w	Ys(a6),d1
	lsr.w	#5,d0
	and.w	#(-(32-1)-1),d1
	lsl.w	#(7-5),d1	; Taille niveau X = 128 = 2^7
	add.w	d1,d0		; only 1 word
	move.l	LevelTestADR(a6),a0
	adda.l	d0,a0

	moveq	#0,d0
	moveq	#SCREEN_Y/32,d2		; 4 or 3 ?
\Loop2:
	moveq	#(SC_X/4-1),d1
\Loop: 
	move.b	(a0),d0		; Get the test
	cmpi.b	#(SpriteAutoStart),d0
	bls.s	\s1
	bsr	NewSprite
\s1:
	addq.l	#1,a0
	dbf.s	d1,\Loop
	lea	(128-SC_X/4)(a0),a0
	dbf.s	d2,\Loop2

	lea	Star_End(a5),a5
	rts

Sprite_100_Coins:
	cmp.w	#100,Coins(a6)
	blt.s	\No
	bsr	FlashScreen
	move.l	LevelTestADR(a6),a0
	move.w	C100_ADR(a5),d0
	move.b	#14,0(a0,d0.w)		; Restore the end.
	moveq	#C100_END,d0
	bra	DestroySprite
\No:	addq.l	#C100_END,a5
	rts

 ifne	SPRITE_EXT
 include "spr_exte.s"
 endif
 ifeq	SPRITE_EXT
Sprite_Nibbles:
Sprite_Plane:
Sprite_Boum:
Sprite_PacMan:
Sprite_Butter_Fly:
Sprite_Ber:
Sprite_Pow:
Sprite_Spider:
 endif




; *****************************************************************
; *****************************************************************
; ***								***
; ***	               Sprite-Routines				***
; ***								***
; *****************************************************************
; *****************************************************************

; Blob-Type
VitesseX:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	move.w  Blob_A(a5),d2
	andi.w  #1,d2
	bne.s	\Conti2
	add.w   Blob_Vx(a5),d0
	bsr	GetTest
	beq.s	\Conti
	cmp.w   #4080,d0
	bhi.s	\Conti
	move.w  d0,Xj(a5)
	bra.s	\Conti2
\Conti:	
	neg.w	Blob_Vx(a5)
\Conti2:
	rts

; DestroyBlob
; Entry : a5 -> Blob-Sprite
; Return : No return

; Destroy:
; Entry : a5 -> Sprite with (Xj and Yj) and d3.l = size of the sprite
; Return : No return
DestroyBlob:
	moveq	#Blob_End,d3
Destroy:
	moveq	#6,d0		; Init explosion 1
	move.w  Xj(a5),d1
	move.w  Yj(a5),d2
	bsr	SpriteInit
	move.l  SpriteADR(a6),a0 ; ATTENTION : Fernando doit tre le premier
	move.w  F_Haut(a0),d0	; de la liste pile
	move.w  d0,F_St(a0)	; Fernando will jump
	move.w  #10,F_Action(a0)
	move.l  d3,d0
	bra	DestroySprite


; Entry  : a5 -> Blob-Sprite
; Return : D2
CalculOfD2:
;	moveq	#0,d2		; the highest 16 bits of d2 must be cleared for putsprite
	move.w  Blob_A(a5),d2
	addq.w  #1,d2
	andi.w  #63,d2
	move.w  d2,Blob_A(a5)
	andi.w  #48,d2
	lsr.w   #4,d2
	add.w   Dessin(a5),d2
	rts

; Entry: a5 -> SpriteLaser (or clone)
; Return : calcul of d0 and d1
ComportementLikeLaser:
	move.w Xj(a5),d0
	move.w Yj(a5),d1
	add.w  LaserVx(a5),d0
	add.w  LaserVy(a5),d1
	move.w d0,Xj(a5)
	move.w d1,Yj(a5)
	rts

; Entry: a5 -> SpriteSun (or clone)
; Return : calcul of d0 and d1
LikeSun:
 move.w	Xs(a6),d0
 move.w	d0,d2
 lsr.w	#4,d0
 neg.w	d0
 add.w	#(SC_X*8),d0
 add.w	d2,d0
 move.w	Ys(a6),d1
 move.w	d1,d2
 lsr.w	#3,d1
 neg.w	d1
 add.w	#(SC_Y),d1
 add.w	d2,d1
 rts

; Entry: a5 -> SpriteStar (or clone), d3 must equal to the Sprite-Test in TestTable
; No return
DestroyStar:
	move.l	LevelTestADR(a6),a0
	move.w	Adresse(a5),d0
	move.b	d3,0(a0,d0.w)
	moveq.l	#Star_End,d0
	bra	DestroySprite


; Make testExitscreen and testcollision
; Entry :	(d0.w, d1.w) = (X,Y)
;		d3.l = Size of the sprite
;		d4.b = Test code of the sprite
; 		a5   = Adress of a sprite (No, Xj, Yj, Adresse and FORCE).
; Return : If the sprite is destroyed, no return.
;		Else update the var and return.
; Destroy : a0 / d2 / d3 / d4
; Warning : You MUST call this routine only in the first level of a sprite
;	    else it crashs !!!!!!!!
; Why ? Because, if it must destroy the current sprite, it will add 4 at 
; the stack to return from your sprite.
SpriteTest:
	bsr	TestExitScreen
	bne.s	\Suite1
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  d4,0(a0,d0.w)
	move.l	d3,d0
	addq.l	#4,a7	; Skip the first return adress
	bra	DestroySprite
\Suite1:
	bsr	TestCollision	; Now test collision...
	bne.s	\No
	cmp.w	Yj(a5),d7
	bge.s	\NoDestroy
	move.l	SpriteADR(a6),a0 ; ATTENTION : Fernando doit tre le premier
	move.w  F_Haut(a0),d2	; de la liste pile
	move.w  d2,F_St(a0)
	move.w  #10,F_Action(a0)
	subq.w	#1,FORCE(a5)
	bne.s	\No
	addq.l	#4,a7	; Skip the first return adress
	bra	Destroy
\NoDestroy
	bsr	Touche
\No:	rts		; Return to the sprite

