;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
; *****************************************************************
; ***								***
; ***	         Correction if game runs too slow		***
; ***								***
; *****************************************************************
; *****************************************************************

; Destroy : d0-d1 / a0-a1

 lea	($600017),a1		; Set a1 to processeur clock for direct port access
 move.l	SpriteADR(a6),a0	; A0 -> Sprite buffer
				; Fernando is the first sprite
 move.b	Frame_Time(a6),d0	; D0 is always equal to Frame_Time
 move.b	LowFlag(a6),d1	; Powerfull waiting for processor's clock (I hope ...)
 beq.s	\Normal		; low condition : Yes / No
 cmp.b	(a1),d0
 bhi.s	\OkRestore	; Ok we can return to real frequency
 add.b	d0,d0		; No, so  Frequency / 2
 bra.s	\Wait		; go to Waiting-loop

\Low:
 st	LowFlag(a6)	; Set Low flag
 move.w	Turbo(a6),d1
 add.w	d1,Turbo(a6)	; Turbo * 2

 and.w	#$FFFC,Time(a6)	; Correct time
 and.w	#$FFFC,F_St(a0)	; Correct jump
			; Some data may be unsynchronized !
 move.w	F_Speed(a0),d1
 add.w	d1,F_Speed(a0)	; Correct Fernando speed

 move.l F_Mx(a0),d1
 add.w	d1,d1
 swap	d1
 add.w	d1,d1
 swap	d1
 move.l	d1,F_Mx(a0)	; Correct propulsor speed

 bra.s	\ExitAutoLow	; Quit

\OkRestore:
 clr.b	LowFlag(a6)		; Clear Low flag
 move.w	Turbo(a6),d1
 asr.w	#1,d1		; Turbo / 2
 move.w	d1,Turbo(a6)

 move.w	F_Speed(a0),d1
 asr.w	#1,d1
 move.w	d1,F_Speed(a0)	; Correct speed of Fernando

 move.l	F_Mx(a0),d1
 asr.w	#1,d1		; Correct F_Mx
 swap	d1
 asr.w	#1,d1		; Correct F_My
 swap	d1
 move.l	d1,F_Mx(a0)	; Correct propulsor X and Y

\Normal:
 move.w	d0,d1
 addq.w	#4,d1		; We let a marge
 cmp.b	(a1),d1	; Test the processor's clock
 blt.s	\Low

\Wait:
 cmp.b	(a1),d0	; Wait for the processor's clock
 bhi.s	\Wait

\ExitAutoLow:
